import { Issue } from './types/issue';
import { Project } from './types/project';
import { AssistedErrorStrategyOption } from './handled-api/common';
interface CacheOptions extends AssistedErrorStrategyOption {
}
export declare class CacheManager {
    private connection;
    private options?;
    private fields?;
    private issueTypes?;
    private priorities?;
    private resolutions?;
    private projects;
    private customFieldOptions;
    constructor(connection: string, options?: CacheOptions | undefined);
    clearCache(): void;
    getAllFields(): Promise<Issue.Field.GetFields.Response.OK>;
    getAllIssueTypes(): Promise<Issue.Type.GetType.Response.OK[]>;
    getProject(projectKey: string): Promise<Project.GetProject.Response.OK>;
    getCustomFieldOption(fieldId: number | string): Promise<Issue.Field.Custom.Option.GetOption.Response.OK>;
    getAllPriorities(): Promise<Issue.Priority.GetPriority.Response.OK[]>;
    getAllResolutions(): Promise<Issue.Resolution.GetResolution.Response.OK[]>;
    private fetchAllFields;
    private fetchAllIssueTypes;
    private fetchProject;
    private fetchCustomFieldOption;
    private fetchAllPriorities;
    private fetchAllResolutions;
}
export {};
//# sourceMappingURL=cacheManager.d.ts.map