import { Group } from './group';
import { Project } from './project';
import { ProjectRole } from './project_role';
import { UserFull } from './user';
export interface Filter {
    favourite: boolean;
    editable: boolean;
    self?: string;
    id?: string;
    name?: string;
    description?: string;
    owner?: UserFull;
    jql?: string;
    viewUrl?: string;
    searchUrl?: string;
    sharePermissions?: FilterPermission[];
    sharedUsers?: {
        size: number;
        'max-results': number;
        'start-index': number;
        'end-index': number;
        items?: UserFull[];
    };
    subscriptions?: {
        size: number;
        'max-results': number;
        'start-index': number;
        'end-index': number;
        items?: {
            id?: number;
            user?: UserFull;
            group?: Group;
        }[];
    };
}
export interface FilterPermission {
    id?: number;
    type?: string;
    project?: Project;
    role?: ProjectRole;
    group?: Group;
    user?: UserFull;
    view: boolean;
    edit: boolean;
}
//# sourceMappingURL=filter.d.ts.map