import { Dashboard } from '../types/dashboard';
/**
 * Returns a list of all dashboards, optionally filtering them.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-list
 * @param options Request options.
 */
export declare function getAllDashboards<T = Dashboard.GetDashboards.Response.OK>(options: Dashboard.GetDashboards.Options.HandledApi): Promise<import("../definitions/dashboard").Dashboards>;
/**
 * Returns a single dashboard.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-getDashboard
 * @param options Request options.
 */
export declare function getDashboardById<T = Dashboard.GetDashboard.Response.OK>(options: Dashboard.GetDashboard.Options.HandledApi): Promise<import("../definitions/dashboard").Dashboard>;
//# sourceMappingURL=dashboard.d.ts.map