import { Filter } from '../../types/filter';
/**
 * Returns the default columns for the given filter. Currently logged in user will be used as the user making such request.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-defaultColumns
 * @param options Request options.
 */
export declare function getFilterDefaultColumns<T = Filter.Column.GetDefaultColumns.Response.OK>(options: Filter.Column.GetDefaultColumns.Options.HandledApi): Promise<Filter.Column.GetDefaultColumns.Response.OK>;
/**
 * Sets the default columns for the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setColumns
 * @param options Request options.
 */
export declare function setFilterDefaultColumns<T = Filter.Column.SetDefaultColumns.Response.OK>(options: Filter.Column.SetDefaultColumns.Options.HandledApi): Promise<undefined>;
/**
 * Resets the columns for the given filter such that the filter no longer has its own column config.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-resetColumns
 * @param options Request options.
 */
export declare function resetFilterColumns<T = Filter.Column.ResetColumns.Response.OK>(options: Filter.Column.ResetColumns.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=column.d.ts.map