import { Filter } from '../../types/filter';
/**
 * Returns the default share scope of the logged-in user.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getDefaultShareScope
 * @param options Request options.
 */
export declare function getDefaultShareScope<T = Filter.Share.GetDefaultScope.Response.OK>(options: Filter.Share.GetDefaultScope.Options.HandledApi): Promise<Filter.Share.GetDefaultScope.Response.OK>;
/**
 * Sets the default share scope of the logged-in user. Available values are GLOBAL and PRIVATE.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setDefaultShareScope
 * @param options Request options.
 */
export declare function setDefaultShareScope<T = Filter.Share.SetDefaultScope.Response.OK>(options: Filter.Share.SetDefaultScope.Options.HandledApi): Promise<Filter.Share.SetDefaultScope.Response.OK>;
//# sourceMappingURL=share.d.ts.map