import { Filter } from '../../../types/filter';
/**
 * Returns all share permissions of the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermissions
 * @param options Request options.
 */
export declare function getFilterSharePermissions<T = Filter.Share.Permission.GetSharePermissions.Response.OK>(options: Filter.Share.Permission.GetSharePermissions.Options.HandledApi): Promise<Filter.Share.Permission.GetSharePermissions.Response.OK>;
/**
 * Adds a share permissions to the given filter. Adding a global permission removes all previous permissions from the filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-addSharePermission
 * @param options Request options.
 */
export declare function addFilterSharePermission<T = Filter.Share.Permission.AddSharePermissions.Response.OK>(options: Filter.Share.Permission.AddSharePermissions.Options.HandledApi): Promise<Filter.Share.Permission.AddSharePermissions.Response.OK>;
/**
 * Returns a single share permission of the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
 * @param options Request options.
 */
export declare function getFilterSharePermission<T = Filter.Share.Permission.GetSharePermission.Response.OK>(options: Filter.Share.Permission.GetSharePermission.Options.HandledApi): Promise<import("../../../definitions/filter").FilterPermission>;
/**
 * Removes a share permissions from the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
 * @param options Request options.
 */
export declare function deleteFilterSharePermission<T = Filter.Share.Permission.DeleteSharePermission.Response.OK>(options: Filter.Share.Permission.DeleteSharePermission.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=permission.d.ts.map