import { Group } from '../types/group';
/**
 * Creates a group by given group parameter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-createGroup
 * @param options Request options.
 */
export declare function createGroup<T = Group.CreateGroup.Response.OK>(options: Group.CreateGroup.Options.HandledApi): Promise<import("../definitions/group").GroupResponse>;
/**
 * Deletes a group by given group parameter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeGroup
 * @param options Request options.
 */
export declare function removeGroup<T = Group.RemoveGroup.Response.OK>(options: Group.RemoveGroup.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=group.d.ts.map