import { executeRequest } from './common';
import { createGroup as createGroupFn, removeGroup as removeGroupFn } from '../raw-api/group';
/**
 * Creates a group by given group parameter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-createGroup
 * @param options Request options.
 */
export function createGroup(options) {
    return executeRequest(() => createGroupFn(options), options.errorStrategy);
}
/**
 * Deletes a group by given group parameter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeGroup
 * @param options Request options.
 */
export function removeGroup(options) {
    return executeRequest(() => removeGroupFn(options), options.errorStrategy);
}
