import { Instance } from '../types/instance';
/**
 * Returns an application property.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-getProperty
 * @param options Request options.
 */
export declare function getApplicationProperty<T = Instance.GetApplicationProperty.Response.OK>(options: Instance.GetApplicationProperty.Options.HandledApi): Promise<import("../definitions/property").Property>;
/**
 * Modify an application property via PUT. The "value" field present in the PUT will override the existing value.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-setPropertyViaRestfulTable
 * @param options Request options.
 */
export declare function setApplicationProperty<T = Instance.SetApplicationProperty.Response.OK>(options: Instance.SetApplicationProperty.Options.HandledApi): Promise<import("../definitions/property").Property>;
/**
 * Returns the properties that are displayed on the "General Configuration > Advanced Settings" page.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-getAdvancedSettings
 * @param options Request options.
 */
export declare function getAdvancedSettings<T = Instance.GetAdvancedSettings.Response.OK>(options: Instance.GetAdvancedSettings.Options.HandledApi): Promise<Instance.GetAdvancedSettings.Response.OK>;
/**
 * Returns the information if the optional features in JIRA are enabled or disabled. If the time tracking is enabled, it also returns the detailed information about time tracking configuration.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/configuration-getConfiguration
 * @param options Request options.
 */
export declare function getInstanceConfiguration<T = Instance.GetConfiguration.Response.OK>(options: Instance.GetConfiguration.Options.HandledApi): Promise<import("../definitions/instance").GetConfigurationResponse>;
/**
 * Returns general information about the current JIRA server.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/serverInfo-getServerInfo
 * @param options Request options.
 */
export declare function getInstanceInfo<T = Instance.GetInfo.Response.OK>(options: Instance.GetInfo.Options.HandledApi): Promise<import("../definitions/instance").GetInfoResponse>;
//# sourceMappingURL=instance.d.ts.map