import { Issue } from '../../types/issue';
/**
 * Returns the meta-data for an attachment, including the URI of the actual attached file.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachment
 * @param options Request options.
 */
export declare function getIssueAttachment<T = Issue.Attachment.GetAttachment.Response.OK>(options: Issue.Attachment.GetAttachment.Options.HandledApi): Promise<import("../../definitions/attachment").Attachment>;
/**
 * Remove an attachment from an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-removeAttachment
 * @param options Request options.
 */
export declare function removeIssueAttachment<T = Issue.Attachment.RemoveAttachment.Response.OK>(options: Issue.Attachment.RemoveAttachment.Options.HandledApi): Promise<undefined>;
/**
 * Add one or more attachments to an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/attachments-addAttachment
 * @param options Request options.
 */
export declare function addIssueAttachment<T = Issue.Attachment.AddAttachment.Response.OK>(options: Issue.Attachment.AddAttachment.Options.HandledApi): Promise<Issue.Attachment.AddAttachment.Response.OK>;
//# sourceMappingURL=attachment.d.ts.map