import { executeRequest } from '../../common';
import { getIssueAttachmentMetadata as getIssueAttachmentMetadataFn } from '../../../raw-api/issue/attachment/metadata';
/**
 * Returns the meta information for an attachments, specifically if they are enabled and the maximum upload size allowed.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachmentMeta
 * @param options Request options.
 */
export function getIssueAttachmentMetadata(options) {
    return executeRequest(() => getIssueAttachmentMetadataFn(options), options.errorStrategy);
}
