import { Issue } from '../../types/issue';
/**
 * Returns all comments for an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComments
 * @param options Request options.
 */
export declare function getIssueComments<T = Issue.Comment.GetComments.Response.OK>(options: Issue.Comment.GetComments.Options.HandledApi): Promise<Issue.Comment.GetComments.Response.OK>;
/**
 * Adds a new comment to an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addComment
 * @param options Request options.
 */
export declare function addIssueComment<T = Issue.Comment.AddComment.Response.OK>(options: Issue.Comment.AddComment.Options.HandledApi): Promise<import("../../definitions/comment").Comment>;
/**
 * Returns a single comment.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComment
 * @param options Request options.
 */
export declare function getIssueComment<T = Issue.Comment.GetComment.Response.OK>(options: Issue.Comment.GetComment.Options.HandledApi): Promise<import("../../definitions/comment").Comment>;
/**
 * Updates an existing comment using its JSON representation.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateComment
 * @param options Request options.
 */
export declare function updateIssueComment<T = Issue.Comment.UpdateComment.Response.OK>(options: Issue.Comment.UpdateComment.Options.HandledApi): Promise<import("../../definitions/comment").Comment>;
/**
 * Deletes an existing comment.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteComment
 * @param options Request options.
 */
export declare function deleteIssueComment<T = Issue.Comment.DeleteComment.Response.OK>(options: Issue.Comment.DeleteComment.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=comment.d.ts.map