import { executeRequest } from '../common';
import { getIssueFields as getIssueFieldsFn } from '../../raw-api/issue/field';
/**
 * Returns a list of all fields, both System and Custom.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/field-getFields
 * @param options Request options.
 */
export function getIssueFields(options) {
    return executeRequest(() => getIssueFieldsFn(options), options.errorStrategy);
}
