import { executeRequest } from '../../../common';
import { getIssueCustomFieldOption as getIssueCustomFieldOptionFn } from '../../../../raw-api/issue/field/custom/option';
/**
 * Returns a full representation of the Custom Field Option that has the given id.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFieldOption-getCustomFieldOption
 * @param options Request options.
 */
export function getIssueCustomFieldOption(options) {
    return executeRequest(() => getIssueCustomFieldOptionFn(options), options.errorStrategy);
}
