import { Issue } from '../../types/issue';
/**
 * Returns a list of all issue priorities.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriorities
 * @param options Request options.
 */
export declare function getIssuePriorities<T = Issue.Priority.GetPriorities.Response.OK>(options: Issue.Priority.GetPriorities.Options.HandledApi): Promise<Issue.Priority.GetPriorities.Response.OK>;
/**
 * Returns an issue priority.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriority
 * @param options Request options.
 */
export declare function getIssuePriority<T = Issue.Priority.GetPriority.Response.OK>(options: Issue.Priority.GetPriority.Options.HandledApi): Promise<import("../../definitions/priority").Priority>;
//# sourceMappingURL=priority.d.ts.map