import { Issue } from '../../types/issue';
/**
 * Returns a list of all resolutions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolutions
 * @param options Request options.
 */
export declare function getIssueResolutions<T = Issue.Resolution.GetResolutions.Response.OK>(options: Issue.Resolution.GetResolutions.Options.HandledApi): Promise<Issue.Resolution.GetResolutions.Response.OK>;
/**
 * Returns a resolution.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolution
 * @param options Request options.
 */
export declare function getIssueResolution<T = Issue.Resolution.GetResolution.Response.OK>(options: Issue.Resolution.GetResolution.Options.HandledApi): Promise<import("../../definitions/resolution").Resolution>;
//# sourceMappingURL=resolution.d.ts.map