import { executeRequest } from '../common';
import { getIssueResolutions as getIssueResolutionsFn, getIssueResolution as getIssueResolutionFn } from '../../raw-api/issue/resolution';
/**
 * Returns a list of all resolutions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolutions
 * @param options Request options.
 */
export function getIssueResolutions(options) {
    return executeRequest(() => getIssueResolutionsFn(options), options.errorStrategy);
}
/**
 * Returns a resolution.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolution
 * @param options Request options.
 */
export function getIssueResolution(options) {
    return executeRequest(() => getIssueResolutionFn(options), options.errorStrategy);
}
