import { executeRequest } from '../common';
import { searchIssuesByJql as searchIssuesByJqlFn } from '../../raw-api/issue/search';
/**
 * Performs a search using JQL.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/search-searchUsingSearchRequest
 * @param options Request options.
 */
export function searchIssuesByJql(options) {
    return executeRequest(() => searchIssuesByJqlFn(options), options.errorStrategy);
}
