import { Issue } from '../../types/issue';
/**
 * Returns an issue's subtask list.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-getSubTasks
 * @param options Request options.
 */
export declare function getIssueSubTasks<T = Issue.SubTask.GetSubTasks.Response.OK>(options: Issue.SubTask.GetSubTasks.Options.HandledApi): Promise<Issue.SubTask.GetSubTasks.Response.OK>;
/**
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-canMoveSubTask
 * @param options Request options.
 */
export declare function canMoveIssueSubTask<T = Issue.SubTask.CanMoveSubTask.Response.OK>(options: Issue.SubTask.CanMoveSubTask.Options.HandledApi): Promise<boolean>;
/**
 * Reorders an issue's subtasks by moving the subtask at index "from" to index "to".
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-moveSubTasks
 * @param options Request options.
 */
export declare function moveIssueSubTasks<T = Issue.SubTask.MoveSubTasks.Response.OK>(options: Issue.SubTask.MoveSubTasks.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=subTask.d.ts.map