import { Issue } from '../../types/issue';
/**
 * Remove your vote from an issue. (i.e. "unvote").
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeVote
 * @param options Request options.
 */
export declare function removeIssueVote<T = Issue.Vote.RemoveVote.Response.OK>(options: Issue.Vote.RemoveVote.Options.HandledApi): Promise<undefined>;
/**
 * Cast your vote in favour of an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addVote
 * @param options Request options.
 */
export declare function addIssueVote<T = Issue.Vote.AddVote.Response.OK>(options: Issue.Vote.AddVote.Options.HandledApi): Promise<undefined>;
/**
 * A REST sub-resource representing the voters on the issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getVotes
 * @param options Request options.
 */
export declare function getIssueVotes<T = Issue.Vote.GetVotes.Response.OK>(options: Issue.Vote.GetVotes.Options.HandledApi): Promise<Issue.Vote.GetVotes.Response.OK>;
//# sourceMappingURL=vote.d.ts.map