import { Issue } from '../../types/issue';
/**
 * Returns the list of watchers for the issue with the given key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssueWatchers
 * @param options Request options.
 */
export declare function getIssueWatchers<T = Issue.Watcher.GetWatchers.Response.OK>(options: Issue.Watcher.GetWatchers.Options.HandledApi): Promise<Issue.Watcher.GetWatchers.Response.OK>;
/**
 * Adds a user to an issue's watcher list.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addWatcher
 * @param options Request options.
 */
export declare function addIssueWatcher<T = Issue.Watcher.AddWatcher.Response.OK>(options: Issue.Watcher.AddWatcher.Options.HandledApi): Promise<undefined>;
/**
 * Removes a user from an issue's watcher list.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeWatcher
 * @param options Request options.
 */
export declare function removeIssueWatcher<T = Issue.Watcher.RemoveWatcher.Response.OK>(options: Issue.Watcher.RemoveWatcher.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=watcher.d.ts.map