import { Permission } from '../types/permission';
/**
 * Returns all permissions that are present in the JIRA instance - Global, Project and the global ones added by plugins
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getAllPermissions
 * @param options Request options.
 */
export declare function getPermissions<T = Permission.GetPermissions.Response.OK>(options: Permission.GetPermissions.Options.HandledApi): Promise<import("../definitions/permissions").Permissions>;
/**
 * Returns all permissions in the system and whether the currently logged in user has them.
 * You can optionally provide a specific context to get permissions for (projectKey OR projectId OR issueKey OR issueId)
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getPermissions
 * @param options Request options.
 */
export declare function getMyPermissions<T = Permission.GetMyPermissions.Response.OK>(options: Permission.GetMyPermissions.Options.HandledApi): Promise<import("../definitions/permissions").Permissions>;
//# sourceMappingURL=permission.d.ts.map