import { Project } from '../../types/project';
/**
 * Create a component via POST.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-createComponent
 * @param options Request options.
 */
export declare function createProjectComponent<T = Project.Component.CreateComponent.Response.OK>(options: Project.Component.CreateComponent.Options.HandledApi): Promise<import("../../definitions/component").Component>;
/**
 * Returns a project component.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponent
 * @param options Request options.
 */
export declare function getProjectComponent<T = Project.Component.GetComponent.Response.OK>(options: Project.Component.GetComponent.Options.HandledApi): Promise<import("../../definitions/component").Component>;
/**
 * Modify a component via PUT. If leadUserName is an empty string ("") the component lead will be removed.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-updateComponent
 * @param options Request options.
 */
export declare function updateProjectComponent<T = Project.Component.UpdateComponent.Response.OK>(options: Project.Component.UpdateComponent.Options.HandledApi): Promise<import("../../definitions/component").Component>;
/**
 * Delete a project component.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-delete
 * @param options Request options.
 */
export declare function deleteProjectComponent<T = Project.Component.DeleteComponent.Response.OK>(options: Project.Component.DeleteComponent.Options.HandledApi): Promise<undefined>;
/**
 * Returns counts of issues related to this component.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponentRelatedIssues
 * @param options Request options.
 */
export declare function getProjectComponentRelatedIssues<T = Project.Component.GetRelatedIssues.Response.OK>(options: Project.Component.GetRelatedIssues.Options.HandledApi): Promise<Project.Component.GetRelatedIssues.Response.OK>;
//# sourceMappingURL=component.d.ts.map