import { Project } from '../../types/project';
/**
 * Returns all roles in the given project Id or key, with links to full details on each role.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRoles
 * @param options Request options.
 */
export declare function getProjectRoles<T = Project.Role.GetRoles.Response.OK>(options: Project.Role.GetRoles.Options.HandledApi): Promise<Record<string, string>>;
/**
 * Returns the details for a given project role in a project.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRole
 * @param options Request options.
 */
export declare function getProjectRole<T = Project.Role.GetRole.Response.OK>(options: Project.Role.GetRole.Options.HandledApi): Promise<import("../../definitions/project_role").ProjectRole>;
//# sourceMappingURL=role.d.ts.map