import { Project } from '../../../types/project';
/**
 * Updates a project role to include the specified actors (users or groups).
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-setActors
 * @param options Request options.
 */
export declare function setProjectRoleActors<T = Project.Role.Actor.SetActors.Response.OK>(options: Project.Role.Actor.SetActors.Options.HandledApi): Promise<import("../../../definitions/project_role").ProjectRole>;
/**
 * Adds an actor (user or group) to a project role.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-addActorUsers
 * @param options Request options.
 */
export declare function addProjectRoleActorUsers<T = Project.Role.Actor.AddUsers.Response.OK>(options: Project.Role.Actor.AddUsers.Options.HandledApi): Promise<import("../../../definitions/project_role").ProjectRole>;
/**
 * Deletes actors (users or groups) from a project role.
 * Delete a user from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?user={username}
 * Delete a group from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?group={groupname}
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-deleteActor
 * @param options Request options.
 */
export declare function deleteProjectRoleActor<T = Project.Role.Actor.DeleteActor.Response.OK>(options: Project.Role.Actor.DeleteActor.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=actor.d.ts.map