import { executeRequest } from '../common';
import { validateProjectKey as validateProjectKeyFn } from '../../raw-api/project/validation';
/**
 * Validates a project key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/projectvalidate-getProject
 * @param options Request options.
 */
export function validateProjectKey(options) {
    return executeRequest(() => validateProjectKeyFn(options), options.errorStrategy);
}
