import { Project } from '../../types/project';
/**
 * Create a version via POST.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-createVersion
 * @param options Request options.
 */
export declare function createProjectVersion<T = Project.Version.CreateVersion.Response.OK>(options: Project.Version.CreateVersion.Options.HandledApi): Promise<import("../../definitions/version").Version>;
/**
 * Modify a version's sequence within a project.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-moveVersion
 * @param options Request options.
 */
export declare function moveProjectVersion<T = Project.Version.MoveVersion.Response.OK>(options: Project.Version.MoveVersion.Options.HandledApi): Promise<import("../../definitions/version").Version>;
/**
 * Returns a project version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersion
 * @param options Request options.
 */
export declare function getProjectVersion<T = Project.Version.GetVersion.Response.OK>(options: Project.Version.GetVersion.Options.HandledApi): Promise<import("../../definitions/version").Version>;
/**
 * Modify a version via PUT. Any fields present in the PUT will override existing values. As a convenience, if a field is not present, it is silently ignored.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-updateVersion
 * @param options Request options.
 */
export declare function updateProjectVersion<T = Project.Version.UpdateVersion.Response.OK>(options: Project.Version.UpdateVersion.Options.HandledApi): Promise<import("../../definitions/version").Version>;
/**
 * Delete a project version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
 * @param options Request options.
 */
export declare function deleteProjectVersion<T = Project.Version.DeleteVersion.Response.OK>(options: Project.Version.DeleteVersion.Options.HandledApi): Promise<undefined>;
/**
 * Merge versions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-merge
 * @param options Request options.
 */
export declare function mergeProjectVersion<T = Project.Version.MergeVersion.Response.OK>(options: Project.Version.MergeVersion.Options.HandledApi): Promise<undefined>;
/**
 * Delete a project version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
 * @param options Request options.
 */
export declare function removeAndReplaceProjectVersion<T = Project.Version.RemoveAndReplaceVersion.Response.OK>(options: Project.Version.RemoveAndReplaceVersion.Options.HandledApi): Promise<undefined>;
//# sourceMappingURL=version.d.ts.map