import { Project } from '../../../types/project';
/**
 * Returns a bean containing the number of fixed in and affected issues for the given version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionRelatedIssues
 * @param options Request options.
 */
export declare function getProjectVersionRelatedIssueCount<T = Project.Version.Count.GetVersionRelatedIssueCount.Response.OK>(options: Project.Version.Count.GetVersionRelatedIssueCount.Options.HandledApi): Promise<Project.Version.Count.GetVersionRelatedIssueCount.Response.OK>;
/**
 * Returns the number of unresolved issues for the given version
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionUnresolvedIssues
 * @param options Request options.
 */
export declare function getProjectVersionUnresolvedIssueCount<T = Project.Version.Count.GetVersionUnresolvedIssueCount.Response.OK>(options: Project.Version.Count.GetVersionUnresolvedIssueCount.Options.HandledApi): Promise<Project.Version.Count.GetVersionUnresolvedIssueCount.Response.OK>;
//# sourceMappingURL=count.d.ts.map