import { Role } from '../../types/role';
/**
 * Get all the ProjectRoles available in JIRA. Currently this list is global.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRoles
 * @param options Request options.
 */
export declare function getGlobalProjectRoles<T = Role.Project.GetRoles.Response.OK>(options: Role.Project.GetRoles.Options.HandledApi): Promise<Role.Project.GetRoles.Response.OK>;
/**
 * Get a specific ProjectRole available in JIRA.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRolesById
 * @param options Request options.
 */
export declare function getGlobalProjectRole<T = Role.Project.GetRole.Response.OK>(options: Role.Project.GetRole.Options.HandledApi): Promise<import("../../definitions/project_role").ProjectRole>;
//# sourceMappingURL=project.d.ts.map