import { getNotificationSchemes as getNotificationSchemesFn } from '../../raw-api/scheme/notification';
import { executeRequest } from '../common';
/**
 * Returns a paginated list of notification schemes.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/notificationscheme-getNotificationSchemes
 * @param options Request options.
 */
export function getNotificationSchemes(options) {
    return executeRequest(() => getNotificationSchemesFn(options), options.errorStrategy);
}
