import { executeRequest } from './common';
import { getWorkflows as getWorkflowsFn } from '../raw-api/workflow';
/**
 * Returns all workflows.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/workflow-getAllWorkflows
 * @param options Request options.
 */
export function getWorkflows(options) {
    return executeRequest(() => getWorkflowsFn(options), options.errorStrategy);
}
