import { Workflow } from '../../types/workflow';
/**
 * Returns a list of all statuses.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatuses
 * @param options Request options.
 */
export declare function getWorkflowStatuses<T = Workflow.Status.GetStatuses.Response.OK>(options: Workflow.Status.GetStatuses.Options.HandledApi): Promise<Workflow.Status.GetStatuses.Response.OK>;
/**
 * Returns a full representation of the Status having the given id or name.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatus
 * @param options Request options.
 */
export declare function getWorkflowStatus<T = Workflow.Status.GetStatus.Response.OK>(options: Workflow.Status.GetStatus.Options.HandledApi): Promise<import("../../definitions/status").Status>;
//# sourceMappingURL=status.d.ts.map