import { Workflow } from '../../../types/workflow';
/**
 * Returns a list of all status categories.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategories
 * @param options Request options.
 */
export declare function getWorkflowStatusCategories<T = Workflow.Status.Category.GetCategories.Response.OK>(options: Workflow.Status.Category.GetCategories.Options.HandledApi): Promise<Workflow.Status.Category.GetCategories.Response.OK>;
/**
 * Returns a full representation of the StatusCategory having the given id or key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategory
 * @param options Request options.
 */
export declare function getWorkflowStatusCategory<T = Workflow.Status.Category.GetCategory.Response.OK>(options: Workflow.Status.Category.GetCategory.Options.HandledApi): Promise<import("../../../definitions/status_category").StatusCategory>;
//# sourceMappingURL=category.d.ts.map