import { CacheManager } from '../cacheManager';
import { CustomFieldReader } from '../reader/customField';
import { IssueBuilder } from '../builder/issue';
export class IssueHelper {
    constructor(connection, options) {
        this.cacheManager = new CacheManager(connection, options);
    }
    static create(connection, options) {
        return new IssueHelper(connection, options);
    }
    async getCustomFieldReader(issue) {
        const fields = await this.cacheManager.getAllFields();
        return new CustomFieldReader(fields, issue);
    }
    getIssueBuilder() {
        return new IssueBuilder(this.cacheManager);
    }
}
