import { createIssue as createIssueFn, deleteIssue as deleteIssueFn, getIssue as getIssueFn, editIssue as editIssueFn, assignIssue as assignIssueFn, sendNotificationForIssue as sendNotificationForIssueFn, injectBuilderForCreateIssueFunction, injectBuilderForEditIssueFunction } from './handled-api/issue';
import { addIssueComment as addIssueCommentFn, getIssueComments as getIssueCommentsFn, getIssueComment as getIssueCommentFn, updateIssueComment as updateIssueCommentFn, deleteIssueComment as deleteIssueCommentFn } from './handled-api/issue/comment';
import { getRemoteIssueLinks as getRemoteIssueLinksFn, createOrUpdateRemoteIssueLink as createOrUpdateRemoteIssueLinkFn, deleteRemoteIssueLinkByGlobalId as deleteRemoteIssueLinkByGlobalIdFn, getRemoteIssueLink as getRemoteIssueLinkFn, updateRemoteIssueLink as updateRemoteIssueLinkFn, deleteRemoteIssueLink as deleteRemoteIssueLinkFn } from './handled-api/issue/link/remote';
import { getIssueWorklogs as getIssueWorklogsFn, addIssueWorklog as addIssueWorklogFn, getIssueWorklog as getIssueWorklogFn, updateIssueWorklog as updateIssueWorklogFn, deleteIssueWorklog as deleteIssueWorklogFn, getDeletedIssueWorklogIds as getDeletedIssueWorklogIdsFn, getIssueWorklogsForIds as getIssueWorklogsForIdsFn, getUpdatedIssueWorklogIds as getUpdatedIssueWorklogIdsFn } from './handled-api/issue/worklog';
import { createProjectComponent as createProjectComponentFn, getProjectComponent as getProjectComponentFn, updateProjectComponent as updateProjectComponentFn, deleteProjectComponent as deleteProjectComponentFn, getProjectComponentRelatedIssues as getProjectComponentRelatedIssuesFn } from './handled-api/project/component';
import { getProjects as getProjectsFn, createProject as createProjectFn, getProject as getProjectFn, updateProject as updateProjectFn, deleteProject as deleteProjectFn, archiveProject as archiveProjectFn, getProjectComponents as getProjectComponentsFn, restoreProject as restoreProjectFn, getProjectStatuses as getProjectStatusesFn, updateProjectType as updateProjectTypeFn, getProjectVersionsPaginated as getProjectVersionsPaginatedFn, getProjectVersions as getProjectVersionsFn } from './handled-api/project';
import { getUser as getUserFn, updateUser as updateUserFn, createUser as createUserFn, removeUser as removeUserFn, addUserToApplication as addUserToApplicationFn, removeUserFromApplication as removeUserFromApplicationFn, changeUserPassword as changeUserPasswordFn } from './handled-api/user';
import { findAssignableUsers as findAssignableUsersFn, findUsersWithAllPermissions as findUsersWithAllPermissionsFn, findUsers as findUsersFn, findUsersWithBrowsePermission as findUsersWithBrowsePermissionFn } from './handled-api/user/search';
import { createProjectVersion as createProjectVersionFn, moveProjectVersion as moveProjectVersionFn, getProjectVersion as getProjectVersionFn, updateProjectVersion as updateProjectVersionFn, deleteProjectVersion as deleteProjectVersionFn, mergeProjectVersion as mergeProjectVersionFn, removeAndReplaceProjectVersion as removeAndReplaceProjectVersionFn } from './handled-api/project/version';
import { getApplicationProperty as getApplicationPropertyFn, setApplicationProperty as setApplicationPropertyFn, getAdvancedSettings as getAdvancedSettingsFn, getInstanceConfiguration as getInstanceConfigurationFn, getInstanceInfo as getInstanceInfoFn } from './handled-api/instance';
import { getWorkflowStatuses as getWorkflowStatusesFn, getWorkflowStatus as getWorkflowStatusFn } from './handled-api/workflow/status';
import { getProjectVersionRelatedIssueCount as getProjectVersionRelatedIssueCountFn, getProjectVersionUnresolvedIssueCount as getProjectVersionUnresolvedIssueCountFn } from './handled-api/project/version/count';
import { getWorkflowStatusCategories as getWorkflowStatusCategoriesFn, getWorkflowStatusCategory as getWorkflowStatusCategoryFn } from './handled-api/workflow/status/category';
import { getProjectRoles as getProjectRolesFn, getProjectRole as getProjectRoleFn } from './handled-api/project/role';
import { getProjectTypes as getProjectTypesFn, getProjectType as getProjectTypeFn, getAccessibleProjectType as getAccessibleProjectTypeFn } from './handled-api/project/type';
import { validateProjectKey as validateProjectKeyFn } from './handled-api/project/validation';
import { setProjectRoleActors as setProjectRoleActorsFn, addProjectRoleActorUsers as addProjectRoleActorUsersFn, deleteProjectRoleActor as deleteProjectRoleActorFn } from './handled-api/project/role/actor';
import { getEditIssueMetadata as getEditIssueMetadataFn, getCreateIssueMetadata as getCreateIssueMetadataFn } from './handled-api/issue/metadata';
import { getIssueResolutions as getIssueResolutionsFn, getIssueResolution as getIssueResolutionFn } from './handled-api/issue/resolution';
import { searchIssuesByJql as searchIssuesByJqlFn } from './handled-api/issue/search';
import { removeIssueVote as removeIssueVoteFn, addIssueVote as addIssueVoteFn, getIssueVotes as getIssueVotesFn } from './handled-api/issue/vote';
import { getIssueWatchers as getIssueWatchersFn, addIssueWatcher as addIssueWatcherFn, removeIssueWatcher as removeIssueWatcherFn } from './handled-api/issue/watcher';
import { getIssueTransitions as getIssueTransitionsFn, performIssueTransition as performIssueTransitionFn } from './handled-api/issue/transition';
import { getIssueSubTasks as getIssueSubTasksFn, canMoveIssueSubTask as canMoveIssueSubTaskFn, moveIssueSubTasks as moveIssueSubTasksFn } from './handled-api/issue/subTask';
import { createIssueLink as createIssueLinkFn, getIssueLink as getIssueLinkFn, deleteIssueLink as deleteIssueLinkFn } from './handled-api/issue/link';
import { getIssueLinkTypes as getIssueLinkTypesFn, getIssueLinkType as getIssueLinkTypeFn, createIssueLinkType as createIssueLinkTypeFn, deleteIssueLinkType as deleteIssueLinkTypeFn, updateIssueLinkType as updateIssueLinkTypeFn } from './handled-api/issue/link/type';
import { createGroup as createGroupFn, removeGroup as removeGroupFn } from './handled-api/group';
import { getIssuePriorities as getIssuePrioritiesFn, getIssuePriority as getIssuePriorityFn } from './handled-api/issue/priority';
import { getUsersFromGroup as getUsersFromGroupFn, addUsersToGroup as addUsersToGroupFn, removeUsersFromGroup as removeUsersFromGroupFn } from './handled-api/group/user';
import { getIssueAttachment as getIssueAttachmentFn, removeIssueAttachment as removeIssueAttachmentFn, addIssueAttachment as addIssueAttachmentFn } from './handled-api/issue/attachment';
import { getIssueType as getIssueTypeFn, getIssueTypes as getIssueTypesFn, createIssueType as createIssueTypeFn, deleteIssueType as deleteIssueTypeFn, updateIssueType as updateIssueTypeFn, getAlternativeIssueTypes as getAlternativeIssueTypesFn } from './handled-api/issue/type';
import { getIssueAttachmentMetadata as getIssueAttachmentMetadataFn } from './handled-api/issue/attachment/metadata';
import { getFilter as getFilterFn } from './handled-api/filter';
import { getGlobalProjectRoles as getGlobalProjectRolesFn, getGlobalProjectRole as getGlobalProjectRoleFn } from './handled-api/role/project';
import { getCurrentUser as getCurrentUserFn } from './handled-api/myself';
import { getIssueFields as getIssueFieldsFn } from './handled-api/issue/field';
import { getIssueCustomFieldOption as getIssueCustomFieldOptionFn } from './handled-api/issue/field/custom/option';
import { getIssueCustomFields as getIssueCustomFieldsFn } from './handled-api/issue/field/custom';
import { getPermissions as getPermissionsFn, getMyPermissions as getMyPermissionsFn } from './handled-api/permission';
import { getAllDashboards as getAllDashboardsFn } from './handled-api/dashboard';
import { getDashboardById as getDashboardByIdFn } from './handled-api/dashboard';
import { getFilterSharePermissions as getFilterSharePermissionsFn, addFilterSharePermission as addFilterSharePermissionFn, getFilterSharePermission as getFilterSharePermissionFn, deleteFilterSharePermission as deleteFilterSharePermissionFn } from './handled-api/filter/share/permission';
import { getMyFavouriteFilters as getMyFavouriteFiltersFn, createFilter as createFilterFn, editFilter as editFilterFn, deleteFilter as deleteFilterFn } from './handled-api/filter';
import { getNotificationSchemes as getNotificationSchemesFn } from './handled-api/scheme/notification';
import { getWorkflows as getWorkflowsFn } from './handled-api/workflow';
import { getFilterDefaultColumns as getFilterDefaultColumnsFn, setFilterDefaultColumns as setFilterDefaultColumnsFn, resetFilterColumns as resetFilterColumnsFn } from './handled-api/filter/column';
import { getDefaultShareScope as getDefaultShareScopeFn, setDefaultShareScope as setDefaultShareScopeFn } from './handled-api/filter/share';
import { ErrorStrategyBuilder } from './builder/errorStrategy';
import { injectBuilders } from './handled-api/common';
import { IssueHelper } from './helper/issue';
export var JiraServerConnection;
(function (JiraServerConnection) {
    function connect(instanceId, options) {
        return new JiraServerInstance(instanceId, options);
    }
    JiraServerConnection.connect = connect;
})(JiraServerConnection || (JiraServerConnection = {}));
export class JiraServerInstance {
    constructor(connection, options) {
        if (!options) {
            options = {};
        }
        options = injectBuilders(options);
        if (options.errorStrategy === undefined) {
            options.errorStrategy = ErrorStrategyBuilder.create()
                .retryOnRateLimiting()
                .build();
        }
        this.connection = connection;
        this.issueHelper = new IssueHelper(connection, options);
        this.All = new AllGroup(connection, options, this.issueHelper);
        this.Builders = new BuildersGroup(this.issueHelper);
        this.Issue = new IssueGroup(connection, options, this.issueHelper);
        this.Filter = new FilterGroup(connection, options);
        this.Group = new GroupGroup(connection, options);
        this.Instance = new InstanceGroup(connection, options);
        this.Project = new ProjectGroup(connection, options);
        this.Myself = new MyselfGroup(connection, options);
        this.Workflow = new WorkflowGroup(connection, options);
        this.User = new UserGroup(connection, options);
        this.Role = new RoleGroup(connection, options);
        this.Permission = new PermissionGroup(connection, options);
        this.Dashboard = new DashboardGroup(connection, options);
        this.Scheme = new SchemeGroup(connection, options);
    }
    /**
     * Performs fetch call using managed connection.
     */
    fetch(url, options) {
        return fetch(url, {
            ...options,
            headers: {
                ...options === null || options === void 0 ? void 0 : options.headers,
                'x-hzn-connection-id': this.connection
            }
        });
    }
    /**
     * Set global error strategy.
     */
    setGlobalErrorStrategy(errorStrategy) {
        const connection = this.connection;
        const options = injectBuilders({ errorStrategy });
        this.issueHelper = new IssueHelper(connection, options);
        this.All = new AllGroup(connection, options, this.issueHelper);
        this.Builders = new BuildersGroup(this.issueHelper);
        this.Issue = new IssueGroup(connection, options, this.issueHelper);
        this.Filter = new FilterGroup(connection, options);
        this.Group = new GroupGroup(connection, options);
        this.Instance = new InstanceGroup(connection, options);
        this.Project = new ProjectGroup(connection, options);
        this.Myself = new MyselfGroup(connection, options);
        this.Workflow = new WorkflowGroup(connection, options);
        this.User = new UserGroup(connection, options);
        this.Role = new RoleGroup(connection, options);
        this.Permission = new PermissionGroup(connection, options);
        this.Dashboard = new DashboardGroup(connection, options);
        this.Scheme = new SchemeGroup(connection, options);
    }
}
class BaseGroup {
    constructor(connection, options) {
        this.connection = connection;
        this.options = options;
    }
    getOptions(options) {
        var _a, _b;
        const injectedOptions = injectBuilders(options);
        const errorStrategy = { ...((_a = this.options.errorStrategy) !== null && _a !== void 0 ? _a : {}), ...((_b = injectedOptions === null || injectedOptions === void 0 ? void 0 : injectedOptions.errorStrategy) !== null && _b !== void 0 ? _b : {}) };
        const newOptions = { connectionId: this.connection, ...options, errorStrategy };
        return injectBuilders(newOptions);
    }
}
class AllGroup extends BaseGroup {
    constructor(connection, options, issueHelper) {
        super(connection, options);
        this.issueHelper = issueHelper;
    }
    /**
     * Create a new issue link type.
     * Recommended usage: Issue.Link.Type.createType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-createIssueLinkType
     * @param options Request options.
     */
    createIssueLinkType(options) {
        return createIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Delete the specified issue link type.
     * Recommended usage: Issue.Link.Type.deleteType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-deleteIssueLinkType
     * @param options Request options.
     */
    deleteIssueLinkType(options) {
        return deleteIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Update the specified issue link type.
     * Recommended usage: Issue.Link.Type.updateType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-updateIssueLinkType
     * @param options Request options.
     */
    updateIssueLinkType(options) {
        return updateIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Returns a list of all alternative issue types for the given issue type id. The list will contain these issues types, to which issues assigned to the given issue type can be migrated.
     * The suitable alternatives are issue types which are assigned to the same workflow, the same field configuration and the same screen scheme.
     * Recommended usage: Issue.Type.getAlternativeTypes
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getAlternativeIssueTypes
     * @param options Request options.
     */
    getAlternativeIssueTypes(options) {
        return getAlternativeIssueTypesFn(this.getOptions(options));
    }
    /**
     * Updates the specified issue type from a JSON representation.
     * Recommended usage: Issue.Type.updateType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-updateIssueType
     * @param options Request options.
     */
    updateIssueType(options) {
        return updateIssueTypeFn(this.getOptions(options));
    }
    /**
     * Deletes the specified issue type. If the issue type has any associated issues, these issues will be migrated to the alternative issue type specified in the parameter.
     * You can determine the alternative issue types by calling the /rest/api/2/issuetype/{id}/alternatives resource.
     * Recommended usage: Issue.Type.deleteType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-deleteIssueType
     * @param options Request options.
     */
    deleteIssueType(options) {
        return deleteIssueTypeFn(this.getOptions(options));
    }
    /**
     * Creates an issue type from a JSON representation and adds the issue newly created issue type to the default issue type scheme.
     * Recommended usage: Issue.Type.createType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-createIssueType
     * @param options Request options.
     */
    createIssueType(options) {
        return createIssueTypeFn(this.getOptions(options));
    }
    /**
     * Returns the default share scope of the logged-in user.
     * Recommended usage: Filter.Share.getShareScope
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getDefaultShareScope
     * @param options Request options.
     */
    getDefaultShareScope(options) {
        return getDefaultShareScopeFn(this.getOptions(options));
    }
    /**
     * Sets the default share scope of the logged-in user. Available values are GLOBAL and PRIVATE.
     * Recommended usage: Filter.Share.setShareScope
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setDefaultShareScope
     * @param options Request options.
     */
    setDefaultShareScope(options) {
        return setDefaultShareScopeFn(this.getOptions(options));
    }
    /**
     * Removes a share permissions from the given filter.
     * Recommended usage: Filter.Share.Permission.deleteSharePermission
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
     * @param options Request options.
     */
    deleteFilterSharePermission(options) {
        return deleteFilterSharePermissionFn(this.getOptions(options));
    }
    /**
     * Returns a single share permission of the given filter.
     * Recommended usage: Filter.Share.Permission.getSharePermissions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
     * @param options Request options.
     */
    getFilterSharePermission(options) {
        return getFilterSharePermissionFn(this.getOptions(options));
    }
    /**
     * Adds a share permissions to the given filter. Adding a global permission removes all previous permissions from the filter.
     * Recommended usage: Filter.Share.Permission.addSharePermission
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-addSharePermission
     * @param options Request options.
     */
    addFilterSharePermission(options) {
        return addFilterSharePermissionFn(this.getOptions(options));
    }
    /**
     * Resets the columns for the given filter such that the filter no longer has its own column config.
     * Recommended usage: Filter.Column.resetColumns
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-resetColumns
     * @param options Request options.
     */
    resetFilterColumns(options) {
        return resetFilterColumnsFn(this.getOptions(options));
    }
    /**
     * Sets the default columns for the given filter.
     * Recommended usage: Filter.Column.setDefaultColumns
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setColumns
     * @param options Request options.
     */
    setFilterDefaultColumns(options) {
        return setFilterDefaultColumnsFn(this.getOptions(options));
    }
    /**
     * Returns the default columns for the given filter. Currently logged in user will be used as the user making such request.
     * Recommended usage: Filter.Column.getDefaultColumns
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-defaultColumns
     * @param options Request options.
     */
    getFilterDefaultColumns(options) {
        return getFilterDefaultColumnsFn(this.getOptions(options));
    }
    /**
     * Delete a filter.
     * Recommended usage: Filter.deleteFilter
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-deleteFilter
     * @param options Request options.
     */
    deleteFilter(options) {
        return deleteFilterFn(this.getOptions(options));
    }
    /**
     * Updates an existing filter, and returns its new value.
     * Recommended usage: Filter.editFilter
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-editFilter
     * @param options Request options.
     */
    editFilter(options) {
        return editFilterFn(this.getOptions(options));
    }
    /**
     * Creates a new filter, and returns newly created filter. Currently sets permissions just using the users default sharing permissions.
     * Recommended usage: Filter.createFilter
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-createFilter
     * @param options Request options.
     */
    createFilter(options) {
        return createFilterFn(this.getOptions(options));
    }
    /**
     * Returns all workflows.
     * Recommended usage: Workflow.getWorkflows
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/workflow-getAllWorkflows
     * @param options Request options.
     */
    getWorkflows(options) {
        return getWorkflowsFn(this.getOptions(options));
    }
    /**
     * Returns a paginated list of notification schemes.
     * Recommended usage: Scheme.Notification.getSchemes
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/notificationscheme-getNotificationSchemes
     * @param options Request options.
     */
    getNotificationSchemes(options) {
        return getNotificationSchemesFn(this.getOptions(options));
    }
    /**
     * Returns the favourite filters of the logged-in user.
     * Recommended usage: Filter.getMyFavouriteFilters
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFavouriteFilters
     * @param options Request options.
     */
    getMyFavouriteFilters(options) {
        return getMyFavouriteFiltersFn(this.getOptions(options));
    }
    /**
     * Returns all share permissions of the given filter.
     * Recommended usage: Filter.Share.Permission.getSharePermissions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermissions
     * @param options Request options.
     */
    getFilterSharePermissions(options) {
        return getFilterSharePermissionsFn(this.getOptions(options));
    }
    /**
     * Returns a list of all dashboards, optionally filtering them.
     * Recommended usage: Dashboard.getDashboards
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-list
     * @param options Request options.
     */
    getAllDashboards(options) {
        return getAllDashboardsFn(this.getOptions(options));
    }
    /**
     * Returns a single dashboard.
     * Recommended usage: Dashboard.getDashboard
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-getDashboard
     * @param options Request options.
     */
    getDashboardById(options) {
        return getDashboardByIdFn(this.getOptions(options));
    }
    /**
     * Returns all permissions in the system and whether the currently logged in user has them.
     * You can optionally provide a specific context to get permissions for (projectKey OR projectId OR issueKey OR issueId).
     * Recommended usage: Permission.getMyPermissions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getPermissions
     * @param options Request options.
     */
    getMyPermissions(options) {
        return getMyPermissionsFn(this.getOptions(options));
    }
    /**
     * Returns all permissions that are present in the JIRA instance - Global, Project and the global ones added by plugins
     * Recommended usage: Permission.getPermissions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getAllPermissions
     * @param options Request options.
     */
    getPermissions(options) {
        return getPermissionsFn(this.getOptions(options));
    }
    /**
     * Get a list of the transitions possible for this issue by the current user, along with fields that are required and their types.
     * Fields will only be returned if expand=transitions.fields.
     * The fields in the metadata correspond to the fields in the transition screen for that transition. Fields not in the screen will not be in the metadata.
     * Recommended usage: Issue.Transition.getTransitions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getTransitions
     * @param options Request options.
     */
    getIssueTransitions(options) {
        return getIssueTransitionsFn(this.getOptions(options));
    }
    /**
     * Perform a transition on an issue. When performing the transition you can update or set other issue fields.
     * The fields that can be set on transtion, in either the fields parameter or the update parameter can be determined using the /rest/api/2/issue/{issueIdOrKey}/transitions?expand=transitions.fields resource. If a field is not configured to appear on the transition screen, then it will not be in the transition metadata, and a field validation error will occur if it is submitted. The updateHistory param adds the issues retrieved by this method to the current user's issue history, if set to true (by default, the issue history does not include issues retrieved via the REST API). You can view the issue history in the JIRA application, via the Issues dropdown or by using the lastViewed JQL field in an issue search.
     * Recommended usage: Issue.Transition.performTransition
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-doTransition
     * @param options Request options.
     */
    performIssueTransition(options) {
        return performIssueTransitionFn(this.getOptions(options));
    }
    /**
     * Returns an issue's subtask list.
     * Recommended usage: Issue.SubTask.getSubTasks
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-getSubTasks
     * @param options Request options.
     */
    getIssueSubTasks(options) {
        return getIssueSubTasksFn(this.getOptions(options));
    }
    /**
     * Returns the information if the optional features in JIRA are enabled or disabled. If the time tracking is enabled, it also returns the detailed information about time tracking configuration.
     * Recommended: Instance.getConfiguration
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/configuration-getConfiguration
     * @param options Request options.
     */
    getInstanceConfiguration(options) {
        return getInstanceConfigurationFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the Custom Field Option that has the given id.
     * Recommended: Issue.Field.Custom.Option.getOption
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFieldOption-getCustomFieldOption
     * @param options Request options.
     */
    getIssueCustomFieldOption(options) {
        return getIssueCustomFieldOptionFn(this.getOptions(options));
    }
    /**
     * Recommended usage: Issue.SubTask.canMoveSubTask
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-canMoveSubTask
     * @param options Request options.
     */
    canMoveIssueSubTask(options) {
        return canMoveIssueSubTaskFn(this.getOptions(options));
    }
    /**
     * Reorders an issue's subtasks by moving the subtask at index "from" to index "to".
     * Recommended usage: Issue.SubTask.moveSubTasks
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-moveSubTasks
     * @param options Request options.
     */
    moveIssueSubTasks(options) {
        return moveIssueSubTasksFn(this.getOptions(options));
    }
    /**
     * Creates an issue link between two issues. The user requires the link issue permission for the issue which will be linked to another issue. The specified link type in the request is used to create the link and will create a link from the first issue to the second issue using the outward description. It also create a link from the second issue to the first issue using the inward description of the issue link type. It will add the supplied comment to the first issue. The comment can have a restriction who can view it. If group is specified, only users of this group can view this comment, if roleLevel is specified only users who have the specified role can view this comment. The user who creates the issue link needs to belong to the specified group or have the specified role.
     * Recommended usage: Issue.Link.createLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLink-linkIssues
     * @param options Request options.
     */
    createIssueLink(options) {
        return createIssueLinkFn(this.getOptions(options));
    }
    /**
     * Returns an issue link with the specified id.
     * Recommended usage: Issue.Link.getLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLink-getIssueLink
     * @param options Request options.
     */
    getIssueLink(options) {
        return getIssueLinkFn(this.getOptions(options));
    }
    /**
     * Deletes an issue link with the specified id. To be able to delete an issue link you must be able to view both issues and must have the link issue permission for at least one of the issues.
     * Recommended usage: Issue.Link.deleteLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLink-deleteIssueLink
     * @param options Request options.
     */
    deleteIssueLink(options) {
        return deleteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Returns a list of available issue link types, if issue linking is enabled. Each issue link type has an id, a name and a label for the outward and inward link relationship.
     * Recommended usage: Issue.Link.Type.getTypes
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-getIssueLinkTypes
     * @param options Request options.
     */
    getIssueLinkTypes(options) {
        return getIssueLinkTypesFn(this.getOptions(options));
    }
    /**
     * Returns for a given issue link type id all information about this issue link type.
     * Recommended usage: Issue.Link.Type.getType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-getIssueLinkType
     * @param options Request options.
     */
    getIssueLinkType(options) {
        return getIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Creates a group by given group parameter.
     * Recommended usage: Group.createGroup
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-createGroup
     * @param options Request options.
     */
    createGroup(options) {
        return createGroupFn(this.getOptions(options));
    }
    /**
     * Deletes a group by given group parameter.
     * Recommended usage: Group.removeGroup
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeGroup
     * @param options Request options.
     */
    removeGroup(options) {
        return removeGroupFn(this.getOptions(options));
    }
    /**
     * This resource returns a paginated list of users who are members of the specified group and its subgroups. Users in the page are ordered by user names. User of this resource is required to have sysadmin or admin permissions.
     * Recommended usage: Group.User.getUsers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-getUsersFromGroup
     * @param options Request options.
     */
    getUsersFromGroup(options) {
        return getUsersFromGroupFn(this.getOptions(options));
    }
    /**
     * Adds given user to a group.
     * Recommended usage: Group.User.addUsers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-addUserToGroup
     * @param options Request options.
     */
    addUsersToGroup(options) {
        return addUsersToGroupFn(this.getOptions(options));
    }
    /**
     * Removes given user from a group.
     * Recommended usage: Group.User.removeUsers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeUserFromGroup
     * @param options Request options.
     */
    removeUsersFromGroup(options) {
        return removeUsersFromGroupFn(this.getOptions(options));
    }
    /**
     * Returns a filter given an id.
     * Recommended usage: Filter.getFilter
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFilter
     * @param options Request options.
     */
    getFilter(options) {
        return getFilterFn(this.getOptions(options));
    }
    /**
     * Returns a list of all fields, both System and Custom.
     * Recommended usage: Issue.Field.getFields
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/field-getFields
     * @param options Request options.
     */
    getIssueFields(options) {
        return getIssueFieldsFn(this.getOptions(options));
    }
    /**
     * Recommended: Issue.Field.Custom.getFields
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFields-getCustomFields
     * @param options Request options.
     */
    getIssueCustomFields(options) {
        return getIssueCustomFieldsFn(this.getOptions(options));
    }
    /**
     * Creates an issue or a sub-task from a JSON representation.
     * The fields that can be set on create, in either the fields parameter or the update parameter can be determined using the /rest/api/2/issue/createmeta resource. If a field is not configured to appear on the create screen, then it will not be in the createmeta, and a field validation error will occur if it is submitted.
     * Creating a sub-task is similar to creating a regular issue, with two important differences:
     * the issueType field must correspond to a sub-task issue type (you can use /issue/createmeta to discover sub-task issue types), and you must provide a parent field in the issue create request containing the id or key of the parent issue.
     * Recommended usage: Issue.createIssue
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-createIssue
     * @param options Request options.
     */
    createIssue(options) {
        return createIssueFn(this.getOptions(injectBuilderForCreateIssueFunction(options, this.connection, this.options)));
    }
    /**
     * Delete an issue. If the issue has subtasks you must set the parameter deleteSubtasks=true to delete the issue. You cannot delete an issue without its subtasks also being deleted.
     * Recommended usage: Issue.deleteIssue
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteIssue
     * @param options Request options.
     */
    deleteIssue(options) {
        return deleteIssueFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the issue for the given issue key.
     * JIRA will attempt to identify the issue by the issueIdOrKey path parameter. This can be an issue id, or an issue key. If the issue cannot be found via an exact match, JIRA will also look for the issue in a case-insensitive way, or by looking to see if the issue was moved. In either of these cases, the request will proceed as normal (a 302 or other redirect will not be returned). The issue key contained in the response will indicate the current value of issue's key.
     * Recommended usage: Issue.getIssue
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssue
     * @param options Request options.
     */
    getIssue(options) {
        return getIssueFn(this.getOptions(options)).then(issue => {
            if (issue && issue.id && issue.key && issue.fields) {
                issue.getCustomFields = () => this.issueHelper.getCustomFieldReader(issue);
            }
            return Promise.resolve(issue);
        });
    }
    /**
     * Edits an issue from a JSON representation.
     * The issue can either be updated by setting explicit the field value(s) or by using an operation to change the field value.
     * The fields that can be updated, in either the fields parameter or the update parameter, can be determined using the /rest/api/2/issue/{issueIdOrKey}/editmeta resource.
     * If a field is not configured to appear on the edit screen, then it will not be in the editmeta, and a field validation error will occur if it is submitted.
     * Specifying a "field_id": field_value in the "fields" is a shorthand for a "set" operation in the "update" section.
     * Field should appear either in "fields" or "update", not in both.
     * Recommended usage: Issue.editIssue
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-editIssue
     * @param options Request options.
     */
    editIssue(options) {
        return editIssueFn(this.getOptions(injectBuilderForEditIssueFunction(options, this.connection, this.options)));
    }
    /**
     * Assigns an issue to a user. You can use this resource to assign issues when the user submitting the request has the assign permission but not the edit issue permission. If the name is "-1" automatic assignee is used. A null name will remove the assignee.
     * Recommended usage: Issue.assignIssue
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-assign
     * @param options Request options.
     */
    assignIssue(options) {
        return assignIssueFn(this.getOptions(options));
    }
    /**
     * Returns all comments for an issue.
     * Recommended usage: Issue.Comment.getComments
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComments
     * @param options Request options.
     */
    getIssueComments(options) {
        return getIssueCommentsFn(this.getOptions(options));
    }
    /**
     * Adds a new comment to an issue.
     * Recommended usage: Issue.Comment.addComment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addComment
     * @param options Request options.
     */
    addIssueComment(options) {
        return addIssueCommentFn(this.getOptions(options));
    }
    /**
     * Returns a single comment.
     * Recommended usage: Issue.Comment.getComment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComment
     * @param options Request options.
     */
    getIssueComment(options) {
        return getIssueCommentFn(this.getOptions(options));
    }
    /**
     * Updates an existing comment using its JSON representation.
     * Recommended usage: Issue.Comment.updateComment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateComment
     * @param options Request options.
     */
    updateIssueComment(options) {
        return updateIssueCommentFn(this.getOptions(options));
    }
    /**
     * Deletes an existing comment.
     * Recommended usage: Issue.Comment.deleteComment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteComment
     * @param options Request options.
     */
    deleteIssueComment(options) {
        return deleteIssueCommentFn(this.getOptions(options));
    }
    /**
     * Returns the meta data for editing an issue. The fields in the editmeta correspond to the fields in the edit screen for the issue. Fields not in the screen will not be in the editmeta.
     * Recommended usage: Issue.Metadata.getEditMetadata
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getEditIssueMeta
     * @param options Request options.
     */
    getEditIssueMetadata(options) {
        return getEditIssueMetadataFn(this.getOptions(options));
    }
    /**
     * Sends a notification (email) to the list or recipients defined in the request.
     * Recommended usage: Issue.sendNotification
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-notify
     * @param options Request options.
     */
    sendNotificationForIssue(options) {
        return sendNotificationForIssueFn(this.getOptions(options));
    }
    /**
     * A REST sub-resource representing the remote issue links on the issue.
     * Recommended usage: Issue.Link.Remote.getLinks
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getRemoteIssueLinks
     * @param options Request options.
     */
    getRemoteIssueLinks(options) {
        return getRemoteIssueLinksFn(this.getOptions(options));
    }
    /**
     * Creates or updates a remote issue link from a JSON representation. If a globalId is provided and a remote issue link exists with that globalId, the remote issue link is updated. Otherwise, the remote issue link is created.
     * Recommended usage: Issue.Link.Remote.createOrUpdateLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-createOrUpdateRemoteIssueLink
     * @param options Request options.
     */
    createOrUpdateRemoteIssueLink(options) {
        return createOrUpdateRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Delete the remote issue link with the given global id on the issue.
     * Recommended usage: Issue.Link.Remote.deleteLinkByGlobalId
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteRemoteIssueLinkByGlobalId
     * @param options Request options.
     */
    deleteRemoteIssueLinkByGlobalId(options) {
        return deleteRemoteIssueLinkByGlobalIdFn(this.getOptions(options));
    }
    /**
     * Get the remote issue link with the given id on the issue.
     * Recommended usage: Issue.Link.Remote.getLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getRemoteIssueLinkById
     * @param options Request options.
     */
    getRemoteIssueLink(options) {
        return getRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Updates a remote issue link from a JSON representation. Any fields not provided are set to null.
     * Recommended usage: Issue.Link.Remote.updateLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateRemoteIssueLink
     * @param options Request options.
     */
    updateRemoteIssueLink(options) {
        return updateRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Delete the remote issue link with the given id on the issue.
     * Recommended usage: Issue.Link.Remote.deleteLink
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteRemoteIssueLinkById
     * @param options Request options.
     */
    deleteRemoteIssueLink(options) {
        return deleteRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Remove your vote from an issue. (i.e. "unvote").
     * Recommended usage: Issue.Vote.removeVote
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeVote
     * @param options Request options.
     */
    removeIssueVote(options) {
        return removeIssueVoteFn(this.getOptions(options));
    }
    /**
     * Cast your vote in favour of an issue.
     * Recommended usage: Issue.Vote.addVote
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addVote
     * @param options Request options.
     */
    addIssueVote(options) {
        return addIssueVoteFn(this.getOptions(options));
    }
    /**
     * A REST sub-resource representing the voters on the issue.
     * Recommended usage: Issue.Vote.getVotes
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getVotes
     * @param options Request options.
     */
    getIssueVotes(options) {
        return getIssueVotesFn(this.getOptions(options));
    }
    /**
     * Returns the list of watchers for the issue with the given key.
     * Recommended usage: Issue.Watcher.getWatchers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssueWatchers
     * @param options Request options.
     */
    getIssueWatchers(options) {
        return getIssueWatchersFn(this.getOptions(options));
    }
    /**
     * Adds a user to an issue's watcher list.
     * Recommended usage: Issue.Watcher.addWatcher
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addWatcher
     * @param options Request options.
     */
    addIssueWatcher(options) {
        return addIssueWatcherFn(this.getOptions(options));
    }
    /**
     * Removes a user from an issue's watcher list.
     * Recommended usage: Issue.Watcher.removeWatcher
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeWatcher
     * @param options Request options.
     */
    removeIssueWatcher(options) {
        return removeIssueWatcherFn(this.getOptions(options));
    }
    /**
     * Returns all work logs for an issue. Work logs won't be returned if the Log work field is hidden for the project.
     * Recommended usage: Issue.Worklog.getWorklogs
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssueWorklog
     * @param options Request options.
     */
    getIssueWorklogs(options) {
        return getIssueWorklogsFn(this.getOptions(options));
    }
    /**
     * Adds a new worklog entry to an issue.
     * Recommended usage: Issue.Worklog.addWorklog
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addWorklog
     * @param options Request options.
     */
    addIssueWorklog(options) {
        return addIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Returns a specific worklog. The work log won't be returned if the Log work field is hidden for the project.
     * Recommended usage: Issue.Worklog.getWorklog
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getWorklog
     * @param options Request options.
     */
    getIssueWorklog(options) {
        return getIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Updates an existing worklog entry. Fields possible for editing are: comment, visibility, started, timeSpent and timeSpentSeconds. Either timeSpent or timeSpentSeconds can be set. Fields which are not set will not be updated. For a request to be valid, it has to have at least one field change.
     * Recommended usage: Issue.Worklog.updateWorklog
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateWorklog
     * @param options Request options.
     */
    updateIssueWorklog(options) {
        return updateIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Deletes an existing worklog entry.
     * Recommended usage: Issue.Worklog.deleteWorklog
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteWorklog
     * @param options Request options.
     */
    deleteIssueWorklog(options) {
        return deleteIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Returns the meta data for creating issues. This includes the available projects, issue types and fields, including field types and whether or not those fields are required. Projects will not be returned if the user does not have permission to create issues in that project.
     * The fields in the createmeta correspond to the fields in the create screen for the project/issuetype. Fields not in the screen will not be in the createmeta.
     * Fields will only be returned if expand=projects.issuetypes.fields.
     * The results can be filtered by project and/or issue type, given by the query params.
     * Recommended usage: Issue.Metadata.getCreateMetadata
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getCreateIssueMeta
     * @param options Request options.
     */
    getCreateIssueMetadata(options) {
        return getCreateIssueMetadataFn(this.getOptions(options));
    }
    /**
     * Returns an application property.
     * Recommended usage: Instance.getApplicationProperty
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-getProperty
     * @param options Request options.
     */
    getApplicationProperty(options) {
        return getApplicationPropertyFn(this.getOptions(options));
    }
    /**
     * Modify an application property via PUT. The "value" field present in the PUT will override the existing value.
     * Recommended usage: Instance.setApplicationProperty
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-setPropertyViaRestfulTable
     * @param options Request options.
     */
    setApplicationProperty(options) {
        return setApplicationPropertyFn(this.getOptions(options));
    }
    /**
     * Returns the properties that are displayed on the "General Configuration > Advanced Settings" page.
     * Recommended usage: Instance.getAdvancedSettings
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-getAdvancedSettings
     * @param options Request options.
     */
    getAdvancedSettings(options) {
        return getAdvancedSettingsFn(this.getOptions(options));
    }
    /**
     * Returns the meta-data for an attachment, including the URI of the actual attached file.
     * Recommended usage: Issue.Attachment.getAttachment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachment
     * @param options Request options.
     */
    getIssueAttachment(options) {
        return getIssueAttachmentFn(this.getOptions(options));
    }
    /**
     * Remove an attachment from an issue.
     * Recommended usage: Issue.Attachment.removeAttachment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-removeAttachment
     * @param options Request options.
     */
    removeIssueAttachment(options) {
        return removeIssueAttachmentFn(this.getOptions(options));
    }
    /**
     * Returns the meta information for an attachments, specifically if they are enabled and the maximum upload size allowed.
     * Recommended usage: Issue.Attachment.Metadata.getMetadata
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachmentMeta
     * @param options Request options.
     */
    getIssueAttachmentMetadata(options) {
        return getIssueAttachmentMetadataFn(this.getOptions(options));
    }
    /**
     * Create a component via POST.
     * Recommended usage: Project.Component.createComponent
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-createComponent
     * @param options Request options.
     */
    createProjectComponent(options) {
        return createProjectComponentFn(this.getOptions(options));
    }
    /**
     * Returns a project component.
     * Recommended usage: Project.Component.getComponent
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponent
     * @param options Request options.
     */
    getProjectComponent(options) {
        return getProjectComponentFn(this.getOptions(options));
    }
    /**
     * Modify a component via PUT. If leadUserName is an empty string ("") the component lead will be removed.
     * Recommended usage: Project.Component.updateComponent
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-updateComponent
     * @param options Request options.
     */
    updateProjectComponent(options) {
        return updateProjectComponentFn(this.getOptions(options));
    }
    /**
     * Delete a project component.
     * Recommended usage: Project.Component.deleteComponent
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-delete
     * @param options Request options.
     */
    deleteProjectComponent(options) {
        return deleteProjectComponentFn(this.getOptions(options));
    }
    /**
     * Returns counts of issues related to this component.
     * Recommended usage: Project.Component.getRelatedIssues
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponentRelatedIssues
     * @param options Request options.
     */
    getProjectComponentRelatedIssues(options) {
        return getProjectComponentRelatedIssuesFn(this.getOptions(options));
    }
    /**
     * Returns a list of all issue types visible to the user.
     * Recommended usage: Issue.Type.getTypes
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getIssueAllTypes
     * @param options Request options.
     */
    getIssueTypes(options) {
        return getIssueTypesFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the issue type that has the given id.
     * Recommended usage: Issue.Type.getType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getIssueType
     * @param options Request options.
     */
    getIssueType(options) {
        return getIssueTypeFn(this.getOptions(options));
    }
    /**
     * Returns currently logged in user.
     * Recommended usage: Myself.getCurrentUser
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/myself-getUser
     * @param options Request options.
     */
    getCurrentUser(options) {
        return getCurrentUserFn(this.getOptions(options));
    }
    /**
     * Returns a list of all issue priorities.
     * Recommended usage: Issue.Priority.getPriorities
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriorities
     * @param options Request options.
     */
    getIssuePriorities(options) {
        return getIssuePrioritiesFn(this.getOptions(options));
    }
    /**
     * Returns an issue priority.
     * Recommended usage: Issue.Priority.getPriority
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriority
     * @param options Request options.
     */
    getIssuePriority(options) {
        return getIssuePriorityFn(this.getOptions(options));
    }
    /**
     * Returns all projects which are visible for the currently logged in user. If no user is logged in, it returns the list of projects that are visible when using anonymous access.
     * Recommended usage: Project.getProjects
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getAllProjects
     * @param options Request options.
     */
    getProjects(options) {
        return getProjectsFn(this.getOptions(options));
    }
    /**
     * Creates a new project.
     * Recommended usage: Project.createProject
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-createProject
     * @param options Request options.
     */
    createProject(options) {
        return createProjectFn(this.getOptions(options));
    }
    /**
     * Contains a full representation of a project in JSON format.
     * Recommended usage: Project.getProject
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProject
     * @param options Request options.
     */
    getProject(options) {
        return getProjectFn(this.getOptions(options));
    }
    /**
     * Updates a project. Only non null values sent in JSON will be updated in the project.
     * Recommended usage: Project.updateProject
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-updateProject
     * @param options Request options.
     */
    updateProject(options) {
        return updateProjectFn(this.getOptions(options));
    }
    /**
     * Deletes a project.
     * Recommended usage: Project.deleteProject
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-deleteProject
     * @param options Request options.
     */
    deleteProject(options) {
        return deleteProjectFn(this.getOptions(options));
    }
    /**
     * Archives a project.
     * Recommended usage: Project.archiveProject
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-archiveProject
     * @param options Request options.
     */
    archiveProject(options) {
        return archiveProjectFn(this.getOptions(options));
    }
    /**
     * Contains a full representation of a the specified project's components.
     * Recommended usage: Project.getComponents
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProjectComponents
     * @param options Request options.
     */
    getProjectComponents(options) {
        return getProjectComponentsFn(this.getOptions(options));
    }
    /**
     * Restore an archived project. In case of success restored project should be re-indexed.
     * Recommended usage: Project.restoreProject
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-restoreProject
     * @param options Request options.
     */
    restoreProject(options) {
        return restoreProjectFn(this.getOptions(options));
    }
    /**
     * Get all issue types with valid status values for a project.
     * Recommended usage: Project.getStatuses
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getAllStatuses
     * @param options Request options.
     */
    getProjectStatuses(options) {
        return getProjectStatusesFn(this.getOptions(options));
    }
    /**
     * Updates the type of a project.
     * Recommended usage: Project.updateProjectType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-updateProjectType
     * @param options Request options.
     */
    updateProjectType(options) {
        return updateProjectTypeFn(this.getOptions(options));
    }
    /**
     * Returns all versions for the specified project. Results are paginated.
     * Recommended usage: Project.getVersionsPaginated
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProjectVersionsPaginated
     * @param options Request options.
     */
    getProjectVersionsPaginated(options) {
        return getProjectVersionsPaginatedFn(this.getOptions(options));
    }
    /**
     * Contains a full representation of a the specified project's versions.
     * Recommended usage: Project.getVersions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProjectVersions
     * @param options Request options.
     */
    getProjectVersions(options) {
        return getProjectVersionsFn(this.getOptions(options));
    }
    /**
     * Returns all roles in the given project Id or key, with links to full details on each role.
     * Recommended usage: Project.Role.getRoles
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRoles
     * @param options Request options.
     */
    getProjectRoles(options) {
        return getProjectRolesFn(this.getOptions(options));
    }
    /**
     * Returns the details for a given project role in a project.
     * Recommended usage: Project.Role.getRole
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRole
     * @param options Request options.
     */
    getProjectRole(options) {
        return getProjectRoleFn(this.getOptions(options));
    }
    /**
     * Updates a project role to include the specified actors (users or groups).
     * Recommended usage: Project.Role.Actor.setActors
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-setActors
     * @param options Request options.
     */
    setProjectRoleActors(options) {
        return setProjectRoleActorsFn(this.getOptions(options));
    }
    /**
     * Adds an actor (user or group) to a project role.
     * Recommended usage: Project.Role.Actor.addUsers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-addActorUsers
     * @param options Request options.
     */
    addProjectRoleActorUsers(options) {
        return addProjectRoleActorUsersFn(this.getOptions(options));
    }
    /**
     * Deletes actors (users or groups) from a project role.
     * Delete a user from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?user={username}
     * Delete a group from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?group={groupname}
     * Recommended usage: Project.Role.Actor.deleteActor
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-deleteActor
     * @param options Request options.
     */
    deleteProjectRoleActor(options) {
        return deleteProjectRoleActorFn(this.getOptions(options));
    }
    /**
     * Returns all the project types defined on the JIRA instance, not taking into account whether the license to use those project types is valid or not.
     * Recommended usage: Project.Type.getTypes
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getAllProjectTypes
     * @param options Request options.
     */
    getProjectTypes(options) {
        return getProjectTypesFn(this.getOptions(options));
    }
    /**
     * Returns the project type with the given key.
     * Recommended usage: Project.Type.getType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getProjectTypeByKey
     * @param options Request options.
     */
    getProjectType(options) {
        return getProjectTypeFn(this.getOptions(options));
    }
    /**
     * Returns the project type with the given key, if it is accessible to the logged in user. This takes into account whether the user is licensed on the Application that defines the project type.
     * Recommended usage: Project.Type.getAccessibleType
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getAccessibleProjectTypeByKey
     * @param options Request options.
     */
    getAccessibleProjectType(options) {
        return getAccessibleProjectTypeFn(this.getOptions(options));
    }
    /**
     * Validates a project key.
     * Recommended usage: Project.Validation.validateProjectKey
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/projectvalidate-getProject
     * @param options Request options.
     */
    validateProjectKey(options) {
        return validateProjectKeyFn(this.getOptions(options));
    }
    /**
     * Returns a list of all resolutions.
     * Recommended usage: Issue.Resolution.getResolutions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolutions
     * @param options Request options.
     */
    getIssueResolutions(options) {
        return getIssueResolutionsFn(this.getOptions(options));
    }
    /**
     * Returns a resolution.
     * Recommended usage: Issue.Resolution.getResolution
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolution
     * @param options Request options.
     */
    getIssueResolution(options) {
        return getIssueResolutionFn(this.getOptions(options));
    }
    /**
     * Performs a search using JQL.
     * Recommended usage: Issue.Search.searchByJql
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/search-searchUsingSearchRequest
     * @param options Request options.
     */
    searchIssuesByJql(options) {
        return searchIssuesByJqlFn(this.getOptions(options));
    }
    /**
     * Returns general information about the current JIRA server.
     * Recommended usage: Instance.getInfo
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/serverInfo-getServerInfo
     * @param options Request options.
     */
    getInstanceInfo(options) {
        return getInstanceInfoFn(this.getOptions(options));
    }
    /**
     * Returns a list of all statuses.
     * Recommended usage: Workflow.Status.getStatuses
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatuses
     * @param options Request options.
     */
    getWorkflowStatuses(options) {
        return getWorkflowStatusesFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the Status having the given id or name.
     * Recommended usage: Workflow.Status.getStatus
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatus
     * @param options Request options.
     */
    getWorkflowStatus(options) {
        return getWorkflowStatusFn(this.getOptions(options));
    }
    /**
     * Returns a list of all status categories.
     * Recommended usage: Workflow.Status.Category.getCategories
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategories
     * @param options Request options.
     */
    getWorkflowStatusCategories(options) {
        return getWorkflowStatusCategoriesFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the StatusCategory having the given id or key.
     * Recommended usage: Workflow.Status.Category.getCategory
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategory
     * @param options Request options.
     */
    getWorkflowStatusCategory(options) {
        return getWorkflowStatusCategoryFn(this.getOptions(options));
    }
    /**
     * Returns a user.
     * Recommended usage: User.getUser
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-getUser
     * @param options Request options.
     */
    getUser(options) {
        return getUserFn(this.getOptions(options));
    }
    /**
     * Modify user. The "value" fields present will override the existing value. Fields skipped in request will not be changed.
     * Recommended usage: User.updateUser
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-updateUser
     * @param options Request options.
     */
    updateUser(options) {
        return updateUserFn(this.getOptions(options));
    }
    /**
     * Create user. By default created user will not be notified with email. If password field is not set then password will be randomly generated.
     * Recommended usage: User.createUser
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-createUser
     * @param options Request options.
     */
    createUser(options) {
        return createUserFn(this.getOptions(options));
    }
    /**
     * Removes user and its references (like project roles associations, watches, history).
     * Recommended usage: User.removeUser
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-removeUser
     * @param options Request options.
     */
    removeUser(options) {
        return removeUserFn(this.getOptions(options));
    }
    /**
     * Add user to given application. Admin permission will be required to perform this operation.
     * Recommended usage: User.addUserToApplication
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-addUserToApplication
     * @param options Request options.
     */
    addUserToApplication(options) {
        return addUserToApplicationFn(this.getOptions(options));
    }
    /**
     * Remove user from given application. Admin permission will be required to perform this operation.
     * Recommended usage: User.removeUserFromApplication
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-removeUserFromApplication
     * @param options Request options.
     */
    removeUserFromApplication(options) {
        return removeUserFromApplicationFn(this.getOptions(options));
    }
    /**
     * Modify user password.
     * Recommended usage: User.changeUserPassword
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-changeUserPassword
     * @param options Request options.
     */
    changeUserPassword(options) {
        return changeUserPasswordFn(this.getOptions(options));
    }
    /**
     * Returns a list of users that match the search string. This resource cannot be accessed anonymously. Please note that this resource should be called with an issue key when a list of assignable users is retrieved for editing. For create only a project key should be supplied. The list of assignable users may be incorrect if it's called with the project key for editing.
     * Recommended usage: User.Search.findAssignableUsers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findAssignableUsers
     * @param options Request options.
     */
    findAssignableUsers(options) {
        return findAssignableUsersFn(this.getOptions(options));
    }
    /**
     * Returns a list of active users that match the search string and have all specified permissions for the project or issue.
     * This resource can be accessed by users with ADMINISTER_PROJECT permission for the project or global ADMIN or SYSADMIN rights.
     * Recommended usage: User.Search.findUsersWithAllPermissions
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findUsersWithAllPermissions
     * @param options Request options.
     */
    findUsersWithAllPermissions(options) {
        return findUsersWithAllPermissionsFn(this.getOptions(options));
    }
    /**
     * Returns a list of users that match the search string. This resource cannot be accessed anonymously.
     * Recommended usage: User.Search.findUsers
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findUsers
     * @param options Request options.
     */
    findUsers(options) {
        return findUsersFn(this.getOptions(options));
    }
    /**
     * Returns a list of active users that match the search string. This resource cannot be accessed anonymously and requires the Browse Users global permission. Given an issue key this resource will provide a list of users that match the search string and have the browse issue permission for the issue provided.
     * Recommended usage: User.Search.findUsersWithBrowsePermission
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findUsersWithBrowsePermission
     * @param options Request options.
     */
    findUsersWithBrowsePermission(options) {
        return findUsersWithBrowsePermissionFn(this.getOptions(options));
    }
    /**
     * Create a version via POST.
     * Recommended usage: Project.Version.createVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-createVersion
     * @param options Request options.
     */
    createProjectVersion(options) {
        return createProjectVersionFn(this.getOptions(options));
    }
    /**
     * Modify a version's sequence within a project.
     * Recommended usage: Project.Version.moveVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-moveVersion
     * @param options Request options.
     */
    moveProjectVersion(options) {
        return moveProjectVersionFn(this.getOptions(options));
    }
    /**
     * Returns a project version.
     * Recommended usage: Project.Version.getVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersion
     * @param options Request options.
     */
    getProjectVersion(options) {
        return getProjectVersionFn(this.getOptions(options));
    }
    /**
     * Modify a version via PUT. Any fields present in the PUT will override existing values. As a convenience, if a field is not present, it is silently ignored.
     * Recommended usage: Project.Version.updateVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-updateVersion
     * @param options Request options.
     */
    updateProjectVersion(options) {
        return updateProjectVersionFn(this.getOptions(options));
    }
    /**
     * Delete a project version.
     * Recommended usage: Project.Version.deleteVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
     * @param options Request options.
     */
    deleteProjectVersion(options) {
        return deleteProjectVersionFn(this.getOptions(options));
    }
    /**
     * Merge versions.
     * Recommended usage: Project.Version.mergeVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-merge
     * @param options Request options.
     */
    mergeProjectVersion(options) {
        return mergeProjectVersionFn(this.getOptions(options));
    }
    /**
     * Delete a project version.
     * Recommended usage: Project.Version.removeAndReplaceVersion
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
     * @param options Request options.
     */
    removeAndReplaceProjectVersion(options) {
        return removeAndReplaceProjectVersionFn(this.getOptions(options));
    }
    /**
     * Returns a bean containing the number of fixed in and affected issues for the given version.
     * Recommended usage: Project.Version.Count.getVersionRelatedIssueCount
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionRelatedIssues
     * @param options Request options.
     */
    getProjectVersionRelatedIssueCount(options) {
        return getProjectVersionRelatedIssueCountFn(this.getOptions(options));
    }
    /**
     * Returns the number of unresolved issues for the given version
     * Recommended usage: Project.Version.Count.getVersionUnresolvedIssueCount
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionUnresolvedIssues
     * @param options Request options.
     */
    getProjectVersionUnresolvedIssueCount(options) {
        return getProjectVersionUnresolvedIssueCountFn(this.getOptions(options));
    }
    /**
     * Returns worklogs id and delete time of worklogs that was deleted since given time. The returns set of worklogs is limited to 1000 elements. This API will not return worklogs deleted during last minute.
     * Recommended usage: Issue.Worklog.getDeletedWorklogIds
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/worklog-getIdsOfWorklogsDeletedSince
     * @param options Request options.
     */
    getDeletedIssueWorklogIds(options) {
        return getDeletedIssueWorklogIdsFn(this.getOptions(options));
    }
    /**
     * Returns worklogs for given worklog ids. Only worklogs to which the calling user has permissions, will be included in the result. The returns set of worklogs is limited to 1000 elements.
     * Recommended usage: Issue.Worklog.getWorklogsForIds
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/worklog-getWorklogsForIds
     * @param options Request options.
     */
    getIssueWorklogsForIds(options) {
        return getIssueWorklogsForIdsFn(this.getOptions(options));
    }
    /**
     * Returns worklogs id and update time of worklogs that was updated since given time. The returns set of worklogs is limited to 1000 elements. This API will not return worklogs updated during last minute.
     * Recommended usage: Issue.Worklog.getUpdatedWorklogIds
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/worklog-getIdsOfWorklogsModifiedSince
     * @param options Request options.
     */
    getUpdatedIssueWorklogIds(options) {
        return getUpdatedIssueWorklogIdsFn(this.getOptions(options));
    }
    /**
    * Get all the ProjectRoles available in JIRA. Currently this list is global.
    * Recommended usage: Role.Project.getRoles
    * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRoles
    * @param options Request options.
    */
    getGlobalProjectRoles(options) {
        return getGlobalProjectRolesFn(this.getOptions(options));
    }
    /**
     * Get a specific ProjectRole available in JIRA.
     * Recommended usage: Role.Project.getRole
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRolesById
     * @param options Request options.
     */
    getGlobalProjectRole(options) {
        return getGlobalProjectRoleFn(this.getOptions(options));
    }
    /**
     * Add one or more attachments to an issue.
     * Recommended usage: Issue.Attachment.addAttachment
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/attachments-addAttachment
     * @param options Request options.
     */
    addIssueAttachment(options) {
        return addIssueAttachmentFn(this.getOptions(options));
    }
}
class BuildersGroup {
    constructor(issueHelper) {
        this.issueHelper = issueHelper;
    }
    get ErrorStrategy() {
        return ErrorStrategyBuilder.create();
    }
    get IssueBuilder() {
        return this.issueHelper.getIssueBuilder();
    }
}
class IssueGroup extends BaseGroup {
    constructor(connection, options, issueHelper) {
        super(connection, options);
        this.issueHelper = issueHelper;
        this.Comment = new CommentGroup(connection, options);
        this.Metadata = new MetadataGroup(connection, options);
        this.Link = new LinkGroup(connection, options);
        this.Vote = new VoteGroup(connection, options);
        this.Watcher = new WatcherGroup(connection, options);
        this.Worklog = new WorklogGroup(connection, options);
        this.Transition = new TransitionGroup(connection, options);
        this.SubTask = new SubTaskGroup(connection, options);
        this.Field = new FieldGroup(connection, options);
        this.Attachment = new AttachmentGroup(connection, options);
        this.Type = new TypeGroup(connection, options);
        this.Priority = new PriorityGroup(connection, options);
        this.Resolution = new ResolutionGroup(connection, options);
        this.Search = new SearchGroup(connection, options);
    }
    /**
     * Creates an issue or a sub-task from a JSON representation.
     * The fields that can be set on create, in either the fields parameter or the update parameter can be determined using the /rest/api/2/issue/createmeta resource. If a field is not configured to appear on the create screen, then it will not be in the createmeta, and a field validation error will occur if it is submitted.
     * Creating a sub-task is similar to creating a regular issue, with two important differences:
     * the issueType field must correspond to a sub-task issue type (you can use /issue/createmeta to discover sub-task issue types), and you must provide a parent field in the issue create request containing the id or key of the parent issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-createIssue
     * @param options Request options.
     */
    createIssue(options) {
        return createIssueFn(this.getOptions(injectBuilderForCreateIssueFunction(options, this.connection, this.options)));
    }
    /**
     * Delete an issue. If the issue has subtasks you must set the parameter deleteSubtasks=true to delete the issue. You cannot delete an issue without its subtasks also being deleted.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteIssue
     * @param options Request options.
     */
    deleteIssue(options) {
        return deleteIssueFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the issue for the given issue key.
     * JIRA will attempt to identify the issue by the issueIdOrKey path parameter. This can be an issue id, or an issue key. If the issue cannot be found via an exact match, JIRA will also look for the issue in a case-insensitive way, or by looking to see if the issue was moved. In either of these cases, the request will proceed as normal (a 302 or other redirect will not be returned). The issue key contained in the response will indicate the current value of issue's key.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssue
     * @param options Request options.
     */
    getIssue(options) {
        return getIssueFn(this.getOptions(options)).then(issue => {
            if (issue && issue.id && issue.key && issue.fields) {
                issue.getCustomFields = () => this.issueHelper.getCustomFieldReader(issue);
            }
            return Promise.resolve(issue);
        });
    }
    /**
     * Edits an issue from a JSON representation.
     * The issue can either be updated by setting explicit the field value(s) or by using an operation to change the field value.
     * The fields that can be updated, in either the fields parameter or the update parameter, can be determined using the /rest/api/2/issue/{issueIdOrKey}/editmeta resource.
     * If a field is not configured to appear on the edit screen, then it will not be in the editmeta, and a field validation error will occur if it is submitted.
     * Specifying a "field_id": field_value in the "fields" is a shorthand for a "set" operation in the "update" section.
     * Field should appear either in "fields" or "update", not in both.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-editIssue
     * @param options Request options.
     */
    editIssue(options) {
        return editIssueFn(this.getOptions(injectBuilderForEditIssueFunction(options, this.connection, this.options)));
    }
    /**
     * Assigns an issue to a user. You can use this resource to assign issues when the user submitting the request has the assign permission but not the edit issue permission. If the name is "-1" automatic assignee is used. A null name will remove the assignee.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-assign
     * @param options Request options.
     */
    assignIssue(options) {
        return assignIssueFn(this.getOptions(options));
    }
    /**
     * Sends a notification (email) to the list or recipients defined in the request.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-notify
     * @param options Request options.
     */
    sendNotification(options) {
        return sendNotificationForIssueFn(this.getOptions(options));
    }
}
class CommentGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns all comments for an issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComments
     * @param options Request options.
     */
    getComments(options) {
        return getIssueCommentsFn(this.getOptions(options));
    }
    /**
     * Adds a new comment to an issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addComment
     * @param options Request options.
     */
    addComment(options) {
        return addIssueCommentFn(this.getOptions(options));
    }
    /**
     * Returns a single comment.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComment
     * @param options Request options.
     */
    getComment(options) {
        return getIssueCommentFn(this.getOptions(options));
    }
    /**
     * Updates an existing comment using its JSON representation.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateComment
     * @param options Request options.
     */
    updateComment(options) {
        return updateIssueCommentFn(this.getOptions(options));
    }
    /**
     * Deletes an existing comment.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteComment
     * @param options Request options.
     */
    deleteComment(options) {
        return deleteIssueCommentFn(this.getOptions(options));
    }
}
class MetadataGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns the meta data for editing an issue. The fields in the editmeta correspond to the fields in the edit screen for the issue. Fields not in the screen will not be in the editmeta.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getEditIssueMeta
     * @param options Request options.
     */
    getEditMetadata(options) {
        return getEditIssueMetadataFn(this.getOptions(options));
    }
    /**
     * Returns the meta data for creating issues. This includes the available projects, issue types and fields, including field types and whether or not those fields are required. Projects will not be returned if the user does not have permission to create issues in that project.
     * The fields in the createmeta correspond to the fields in the create screen for the project/issuetype. Fields not in the screen will not be in the createmeta.
     * Fields will only be returned if expand=projects.issuetypes.fields.
     * The results can be filtered by project and/or issue type, given by the query params.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getCreateIssueMeta
     * @param options Request options.
     */
    getCreateMetadata(options) {
        return getCreateIssueMetadataFn(this.getOptions(options));
    }
}
class LinkGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Type = new LinkTypeGroup(connection, options);
        this.Remote = new RemoteGroup(connection, options);
    }
    /**
     * Creates an issue link between two issues. The user requires the link issue permission for the issue which will be linked to another issue. The specified link type in the request is used to create the link and will create a link from the first issue to the second issue using the outward description. It also create a link from the second issue to the first issue using the inward description of the issue link type. It will add the supplied comment to the first issue. The comment can have a restriction who can view it. If group is specified, only users of this group can view this comment, if roleLevel is specified only users who have the specified role can view this comment. The user who creates the issue link needs to belong to the specified group or have the specified role.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLink-linkIssues
     * @param options Request options.
     */
    createLink(options) {
        return createIssueLinkFn(this.getOptions(options));
    }
    /**
     * Returns an issue link with the specified id.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLink-getIssueLink
     * @param options Request options.
     */
    getLink(options) {
        return getIssueLinkFn(this.getOptions(options));
    }
    /**
     * Deletes an issue link with the specified id. To be able to delete an issue link you must be able to view both issues and must have the link issue permission for at least one of the issues.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLink-deleteIssueLink
     * @param options Request options.
     */
    deleteLink(options) {
        return deleteIssueLinkFn(this.getOptions(options));
    }
}
class RemoteGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * A REST sub-resource representing the remote issue links on the issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getRemoteIssueLinks
     * @param options Request options.
     */
    getLinks(options) {
        return getRemoteIssueLinksFn(this.getOptions(options));
    }
    /**
     * Creates or updates a remote issue link from a JSON representation. If a globalId is provided and a remote issue link exists with that globalId, the remote issue link is updated. Otherwise, the remote issue link is created.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-createOrUpdateRemoteIssueLink
     * @param options Request options.
     */
    createOrUpdateLink(options) {
        return createOrUpdateRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Delete the remote issue link with the given global id on the issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteRemoteIssueLinkByGlobalId
     * @param options Request options.
     */
    deleteLinkByGlobalId(options) {
        return deleteRemoteIssueLinkByGlobalIdFn(this.getOptions(options));
    }
    /**
     * Get the remote issue link with the given id on the issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getRemoteIssueLinkById
     * @param options Request options.
     */
    getLink(options) {
        return getRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Updates a remote issue link from a JSON representation. Any fields not provided are set to null.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateRemoteIssueLink
     * @param options Request options.
     */
    updateLink(options) {
        return updateRemoteIssueLinkFn(this.getOptions(options));
    }
    /**
     * Delete the remote issue link with the given id on the issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteRemoteIssueLinkById
     * @param options Request options.
     */
    deleteLink(options) {
        return deleteRemoteIssueLinkFn(this.getOptions(options));
    }
}
class VoteGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Remove your vote from an issue. (i.e. "unvote").
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeVote
     * @param options Request options.
     */
    removeVote(options) {
        return removeIssueVoteFn(this.getOptions(options));
    }
    /**
     * Cast your vote in favour of an issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addVote
     * @param options Request options.
     */
    addVote(options) {
        return addIssueVoteFn(this.getOptions(options));
    }
    /**
     * A REST sub-resource representing the voters on the issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getVotes
     * @param options Request options.
     */
    getVotes(options) {
        return getIssueVotesFn(this.getOptions(options));
    }
}
class WatcherGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns the list of watchers for the issue with the given key.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssueWatchers
     * @param options Request options.
     */
    getWatchers(options) {
        return getIssueWatchersFn(this.getOptions(options));
    }
    /**
     * Adds a user to an issue's watcher list.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addWatcher
     * @param options Request options.
     */
    addWatcher(options) {
        return addIssueWatcherFn(this.getOptions(options));
    }
    /**
     * Removes a user from an issue's watcher list.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeWatcher
     * @param options Request options.
     */
    removeWatcher(options) {
        return removeIssueWatcherFn(this.getOptions(options));
    }
}
class WorklogGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns all work logs for an issue. Work logs won't be returned if the Log work field is hidden for the project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssueWorklog
     * @param options Request options.
     */
    getWorklogs(options) {
        return getIssueWorklogsFn(this.getOptions(options));
    }
    /**
     * Adds a new worklog entry to an issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addWorklog
     * @param options Request options.
     */
    addWorklog(options) {
        return addIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Returns a specific worklog. The work log won't be returned if the Log work field is hidden for the project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getWorklog
     * @param options Request options.
     */
    getWorklog(options) {
        return getIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Updates an existing worklog entry. Fields possible for editing are: comment, visibility, started, timeSpent and timeSpentSeconds. Either timeSpent or timeSpentSeconds can be set. Fields which are not set will not be updated. For a request to be valid, it has to have at least one field change.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateWorklog
     * @param options Request options.
     */
    updateWorklog(options) {
        return updateIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Deletes an existing worklog entry.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteWorklog
     * @param options Request options.
     */
    deleteWorklog(options) {
        return deleteIssueWorklogFn(this.getOptions(options));
    }
    /**
     * Returns worklogs id and delete time of worklogs that was deleted since given time. The returns set of worklogs is limited to 1000 elements. This API will not return worklogs deleted during last minute.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/worklog-getIdsOfWorklogsDeletedSince
     * @param options Request options.
     */
    getDeletedWorklogIds(options) {
        return getDeletedIssueWorklogIdsFn(this.getOptions(options));
    }
    /**
     * Returns worklogs for given worklog ids. Only worklogs to which the calling user has permissions, will be included in the result. The returns set of worklogs is limited to 1000 elements.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/worklog-getWorklogsForIds
     * @param options Request options.
     */
    getWorklogsForIds(options) {
        return getIssueWorklogsForIdsFn(this.getOptions(options));
    }
    /**
     * Returns worklogs id and update time of worklogs that was updated since given time. The returns set of worklogs is limited to 1000 elements. This API will not return worklogs updated during last minute.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/worklog-getIdsOfWorklogsModifiedSince
     * @param options Request options.
     */
    getUpdatedWorklogIds(options) {
        return getUpdatedIssueWorklogIdsFn(this.getOptions(options));
    }
}
class TransitionGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Get a list of the transitions possible for this issue by the current user, along with fields that are required and their types.
     * Fields will only be returned if expand=transitions.fields.
     * The fields in the metadata correspond to the fields in the transition screen for that transition. Fields not in the screen will not be in the metadata.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getTransitions
     * @param options Request options.
     */
    getTransitions(options) {
        return getIssueTransitionsFn(this.getOptions(options));
    }
    /**
     * Perform a transition on an issue. When performing the transition you can update or set other issue fields.
     * The fields that can be set on transtion, in either the fields parameter or the update parameter can be determined using the /rest/api/2/issue/{issueIdOrKey}/transitions?expand=transitions.fields resource. If a field is not configured to appear on the transition screen, then it will not be in the transition metadata, and a field validation error will occur if it is submitted. The updateHistory param adds the issues retrieved by this method to the current user's issue history, if set to true (by default, the issue history does not include issues retrieved via the REST API). You can view the issue history in the JIRA application, via the Issues dropdown or by using the lastViewed JQL field in an issue search.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-doTransition
     * @param options Request options.
     */
    performTransition(options) {
        return performIssueTransitionFn(this.getOptions(options));
    }
}
class SubTaskGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns an issue's subtask list.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-getSubTasks
     * @param options Request options.
     */
    getSubTasks(options) {
        return getIssueSubTasksFn(this.getOptions(options));
    }
    /**
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-canMoveSubTask
     * @param options Request options.
     */
    canMoveSubTask(options) {
        return canMoveIssueSubTaskFn(this.getOptions(options));
    }
    /**
     * Reorders an issue's subtasks by moving the subtask at index "from" to index "to".
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-moveSubTasks
     * @param options Request options.
     */
    moveSubTasks(options) {
        return moveIssueSubTasksFn(this.getOptions(options));
    }
}
class LinkTypeGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of available issue link types, if issue linking is enabled. Each issue link type has an id, a name and a label for the outward and inward link relationship.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-getIssueLinkTypes
     * @param options Request options.
     */
    getTypes(options) {
        return getIssueLinkTypesFn(this.getOptions(options));
    }
    /**
     * Returns for a given issue link type id all information about this issue link type.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-getIssueLinkType
     * @param options Request options.
     */
    getType(options) {
        return getIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Create a new issue link type.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-createIssueLinkType
     * @param options Request options.
     */
    createType(options) {
        return createIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Delete the specified issue link type.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-deleteIssueLinkType
     * @param options Request options.
     */
    deleteType(options) {
        return deleteIssueLinkTypeFn(this.getOptions(options));
    }
    /**
     * Update the specified issue link type.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-updateIssueLinkType
     * @param options Request options.
     */
    updateType(options) {
        return updateIssueLinkTypeFn(this.getOptions(options));
    }
}
class AttachmentGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Metadata = new AttachmentMetadataGroup(connection, options);
    }
    /**
     * Returns the meta-data for an attachment, including the URI of the actual attached file.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachment
     * @param options Request options.
     */
    getAttachment(options) {
        return getIssueAttachmentFn(this.getOptions(options));
    }
    /**
     * Remove an attachment from an issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-removeAttachment
     * @param options Request options.
     */
    removeAttachment(options) {
        return removeIssueAttachmentFn(this.getOptions(options));
    }
    /**
     * Add one or more attachments to an issue.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/attachments-addAttachment
     * @param options Request options.
     */
    addAttachment(options) {
        return addIssueAttachmentFn(this.getOptions(options));
    }
}
class AttachmentMetadataGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns the meta information for an attachments, specifically if they are enabled and the maximum upload size allowed.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachmentMeta
     * @param options Request options.
     */
    getMetadata(options) {
        return getIssueAttachmentMetadataFn(this.getOptions(options));
    }
}
class GroupGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.User = new GroupUserGroup(connection, options);
    }
    /**
     * Creates a group by given group parameter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-createGroup
     * @param options Request options.
     */
    createGroup(options) {
        return createGroupFn(this.getOptions(options));
    }
    /**
     * Deletes a group by given group parameter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeGroup
     * @param options Request options.
     */
    removeGroup(options) {
        return removeGroupFn(this.getOptions(options));
    }
}
class GroupUserGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * This resource returns a paginated list of users who are members of the specified group and its subgroups. Users in the page are ordered by user names. User of this resource is required to have sysadmin or admin permissions.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-getUsersFromGroup
     * @param options Request options.
     */
    getUsers(options) {
        return getUsersFromGroupFn(this.getOptions(options));
    }
    /**
     * Adds given user to a group.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-addUserToGroup
     * @param options Request options.
     */
    addUsers(options) {
        return addUsersToGroupFn(this.getOptions(options));
    }
    /**
     * Removes given user from a group.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeUserFromGroup
     * @param options Request options.
     */
    removeUsers(options) {
        return removeUsersFromGroupFn(this.getOptions(options));
    }
}
class FilterGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Column = new FilterColumnGroup(connection, options);
        this.Share = new FilterShareGroup(connection, options);
    }
    /**
     * Returns a filter given an id.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFilter
     * @param options Request options.
     */
    getFilter(options) {
        return getFilterFn(this.getOptions(options));
    }
    /**
     * Returns the favourite filters of the logged-in user.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFavouriteFilters
     * @param options Request options.
     */
    getMyFavouriteFilters(options) {
        return getMyFavouriteFiltersFn(this.getOptions(options));
    }
    /**
     * Creates a new filter, and returns newly created filter. Currently sets permissions just using the users default sharing permissions.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-createFilter
     * @param options Request options.
     */
    createFilter(options) {
        return createFilterFn(this.getOptions(options));
    }
    /**
     * Updates an existing filter, and returns its new value.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-editFilter
     * @param options Request options.
     */
    editFilter(options) {
        return editFilterFn(this.getOptions(options));
    }
    /**
     * Delete a filter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-deleteFilter
     * @param options Request options.
     */
    deleteFilter(options) {
        return deleteFilterFn(this.getOptions(options));
    }
}
class FieldGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Custom = new CustomGroup(connection, options);
    }
    /**
     * Returns a list of all fields, both System and Custom.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/field-getFields
     * @param options Request options.
     */
    getFields(options) {
        return getIssueFieldsFn(this.getOptions(options));
    }
}
class InstanceGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns an application property.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-getProperty
     * @param options Request options.
     */
    getApplicationProperty(options) {
        return getApplicationPropertyFn(this.getOptions(options));
    }
    /**
     * Modify an application property via PUT. The "value" field present in the PUT will override the existing value.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-setPropertyViaRestfulTable
     * @param options Request options.
     */
    setApplicationProperty(options) {
        return setApplicationPropertyFn(this.getOptions(options));
    }
    /**
     * Returns the properties that are displayed on the "General Configuration > Advanced Settings" page.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/application-properties-getAdvancedSettings
     * @param options Request options.
     */
    getAdvancedSettings(options) {
        return getAdvancedSettingsFn(this.getOptions(options));
    }
    /**
     * Returns the information if the optional features in JIRA are enabled or disabled. If the time tracking is enabled, it also returns the detailed information about time tracking configuration.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/configuration-getConfiguration
     * @param options Request options.
     */
    getConfiguration(options) {
        return getInstanceConfigurationFn(this.getOptions(options));
    }
    /**
     * Returns general information about the current JIRA server.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/serverInfo-getServerInfo
     * @param options Request options.
     */
    getInfo(options) {
        return getInstanceInfoFn(this.getOptions(options));
    }
}
class ProjectGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Component = new ComponentGroup(connection, options);
        this.Role = new ProjectRoleGroup(connection, options);
        this.Type = new ProjectTypeGroup(connection, options);
        this.Validation = new ProjectValidationGroup(connection, options);
        this.Version = new ProjectVersionGroup(connection, options);
    }
    /**
     * Returns all projects which are visible for the currently logged in user. If no user is logged in, it returns the list of projects that are visible when using anonymous access.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getAllProjects
     * @param options Request options.
     */
    getProjects(options) {
        return getProjectsFn(this.getOptions(options));
    }
    /**
     * Creates a new project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-createProject
     * @param options Request options.
     */
    createProject(options) {
        return createProjectFn(this.getOptions(options));
    }
    /**
     * Contains a full representation of a project in JSON format.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProject
     * @param options Request options.
     */
    getProject(options) {
        return getProjectFn(this.getOptions(options));
    }
    /**
     * Updates a project. Only non null values sent in JSON will be updated in the project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-updateProject
     * @param options Request options.
     */
    updateProject(options) {
        return updateProjectFn(this.getOptions(options));
    }
    /**
     * Deletes a project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-deleteProject
     * @param options Request options.
     */
    deleteProject(options) {
        return deleteProjectFn(this.getOptions(options));
    }
    /**
     * Archives a project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-archiveProject
     * @param options Request options.
     */
    archiveProject(options) {
        return archiveProjectFn(this.getOptions(options));
    }
    /**
     * Contains a full representation of a the specified project's components.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProjectComponents
     * @param options Request options.
     */
    getComponents(options) {
        return getProjectComponentsFn(this.getOptions(options));
    }
    /**
     * Restore an archived project. In case of success restored project should be re-indexed.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-restoreProject
     * @param options Request options.
     */
    restoreProject(options) {
        return restoreProjectFn(this.getOptions(options));
    }
    /**
     * Get all issue types with valid status values for a project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getAllStatuses
     * @param options Request options.
     */
    getStatuses(options) {
        return getProjectStatusesFn(this.getOptions(options));
    }
    /**
     * Updates the type of a project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-updateProjectType
     * @param options Request options.
     */
    updateProjectType(options) {
        return updateProjectTypeFn(this.getOptions(options));
    }
    /**
     * Returns all versions for the specified project. Results are paginated.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProjectVersionsPaginated
     * @param options Request options.
     */
    getVersionsPaginated(options) {
        return getProjectVersionsPaginatedFn(this.getOptions(options));
    }
    /**
     * Contains a full representation of a the specified project's versions.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project-getProjectVersions
     * @param options Request options.
     */
    getVersions(options) {
        return getProjectVersionsFn(this.getOptions(options));
    }
}
class ComponentGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Create a component via POST.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-createComponent
     * @param options Request options.
     */
    createComponent(options) {
        return createProjectComponentFn(this.getOptions(options));
    }
    /**
     * Returns a project component.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponent
     * @param options Request options.
     */
    getComponent(options) {
        return getProjectComponentFn(this.getOptions(options));
    }
    /**
     * Modify a component via PUT. If leadUserName is an empty string ("") the component lead will be removed.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-updateComponent
     * @param options Request options.
     */
    updateComponent(options) {
        return updateProjectComponentFn(this.getOptions(options));
    }
    /**
     * Delete a project component.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-delete
     * @param options Request options.
     */
    deleteComponent(options) {
        return deleteProjectComponentFn(this.getOptions(options));
    }
    /**
     * Returns counts of issues related to this component.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponentRelatedIssues
     * @param options Request options.
     */
    getRelatedIssues(options) {
        return getProjectComponentRelatedIssuesFn(this.getOptions(options));
    }
}
class CustomGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Option = new OptionGroup(connection, options);
    }
    /**
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFields-getCustomFields
     * @param options Request options.
     */
    getFields(options) {
        return getIssueCustomFieldsFn(this.getOptions(options));
    }
}
class OptionGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a full representation of the Custom Field Option that has the given id.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFieldOption-getCustomFieldOption
     * @param options Request options.
     */
    getOption(options) {
        return getIssueCustomFieldOptionFn(this.getOptions(options));
    }
}
class TypeGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of all issue types visible to the user.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getIssueAllTypes
     * @param options Request options.
     */
    getTypes(options) {
        return getIssueTypesFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the issue type that has the given id.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getIssueType
     * @param options Request options.
     */
    getType(options) {
        return getIssueTypeFn(this.getOptions(options));
    }
    /**
     * Creates an issue type from a JSON representation and adds the issue newly created issue type to the default issue type scheme.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-createIssueType
     * @param options Request options.
     */
    createType(options) {
        return createIssueTypeFn(this.getOptions(options));
    }
    /**
     * Deletes the specified issue type. If the issue type has any associated issues, these issues will be migrated to the alternative issue type specified in the parameter.
     * You can determine the alternative issue types by calling the /rest/api/2/issuetype/{id}/alternatives resource.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-deleteIssueType
     * @param options Request options.
     */
    deleteType(options) {
        return deleteIssueTypeFn(this.getOptions(options));
    }
    /**
     * Updates the specified issue type from a JSON representation.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-updateIssueType
     * @param options Request options.
     */
    updateType(options) {
        return updateIssueTypeFn(this.getOptions(options));
    }
    /**
     * Returns a list of all alternative issue types for the given issue type id. The list will contain these issues types, to which issues assigned to the given issue type can be migrated.
     * The suitable alternatives are issue types which are assigned to the same workflow, the same field configuration and the same screen scheme.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getAlternativeIssueTypes
     * @param options Request options.
     */
    getAlternativeTypes(options) {
        return getAlternativeIssueTypesFn(this.getOptions(options));
    }
}
class MyselfGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns currently logged in user.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/myself-getUser
     * @param options Request options.
     */
    getCurrentUser(options) {
        return getCurrentUserFn(this.getOptions(options));
    }
}
class PriorityGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of all issue priorities.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriorities
     * @param options Request options.
     */
    getPriorities(options) {
        return getIssuePrioritiesFn(this.getOptions(options));
    }
    /**
     * Returns an issue priority.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriority
     * @param options Request options.
     */
    getPriority(options) {
        return getIssuePriorityFn(this.getOptions(options));
    }
}
class ProjectRoleGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Actor = new RoleActorGroup(connection, options);
    }
    /**
     * Returns all roles in the given project Id or key, with links to full details on each role.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRoles
     * @param options Request options.
     */
    getRoles(options) {
        return getProjectRolesFn(this.getOptions(options));
    }
    /**
     * Returns the details for a given project role in a project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRole
     * @param options Request options.
     */
    getRole(options) {
        return getProjectRoleFn(this.getOptions(options));
    }
}
class RoleActorGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Updates a project role to include the specified actors (users or groups).
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-setActors
     * @param options Request options.
     */
    setActors(options) {
        return setProjectRoleActorsFn(this.getOptions(options));
    }
    /**
     * Adds an actor (user or group) to a project role.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-addActorUsers
     * @param options Request options.
     */
    addUsers(options) {
        return addProjectRoleActorUsersFn(this.getOptions(options));
    }
    /**
     * Deletes actors (users or groups) from a project role.
     * Delete a user from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?user={username}
     * Delete a group from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?group={groupname}
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-deleteActor
     * @param options Request options.
     */
    deleteActor(options) {
        return deleteProjectRoleActorFn(this.getOptions(options));
    }
}
class ProjectTypeGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns all the project types defined on the JIRA instance, not taking into account whether the license to use those project types is valid or not.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getAllProjectTypes
     * @param options Request options.
     */
    getTypes(options) {
        return getProjectTypesFn(this.getOptions(options));
    }
    /**
     * Returns the project type with the given key.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getProjectTypeByKey
     * @param options Request options.
     */
    getType(options) {
        return getProjectTypeFn(this.getOptions(options));
    }
    /**
     * Returns the project type with the given key, if it is accessible to the logged in user. This takes into account whether the user is licensed on the Application that defines the project type.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getAccessibleProjectTypeByKey
     * @param options Request options.
     */
    getAccessibleType(options) {
        return getAccessibleProjectTypeFn(this.getOptions(options));
    }
}
class ProjectValidationGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Validates a project key.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/projectvalidate-getProject
     * @param options Request options.
     */
    validateProjectKey(options) {
        return validateProjectKeyFn(this.getOptions(options));
    }
}
class ResolutionGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of all resolutions.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolutions
     * @param options Request options.
     */
    getResolutions(options) {
        return getIssueResolutionsFn(this.getOptions(options));
    }
    /**
     * Returns a resolution.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolution
     * @param options Request options.
     */
    getResolution(options) {
        return getIssueResolutionFn(this.getOptions(options));
    }
}
class SearchGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Performs a search using JQL.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/search-searchUsingSearchRequest
     * @param options Request options.
     */
    searchByJql(options) {
        return searchIssuesByJqlFn(this.getOptions(options));
    }
}
class WorkflowGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Status = new WorkflowStatusGroup(connection, options);
    }
    /**
     * Returns all workflows.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/workflow-getAllWorkflows
     * @param options Request options.
     */
    getWorkflows(options) {
        return getWorkflowsFn(this.getOptions(options));
    }
}
class WorkflowStatusGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Category = new StatusCategoryGroup(connection, options);
    }
    /**
     * Returns a list of all statuses.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatuses
     * @param options Request options.
     */
    getStatuses(options) {
        return getWorkflowStatusesFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the Status having the given id or name.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatus
     * @param options Request options.
     */
    getStatus(options) {
        return getWorkflowStatusFn(this.getOptions(options));
    }
}
class StatusCategoryGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of all status categories.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategories
     * @param options Request options.
     */
    getCategories(options) {
        return getWorkflowStatusCategoriesFn(this.getOptions(options));
    }
    /**
     * Returns a full representation of the StatusCategory having the given id or key.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategory
     * @param options Request options.
     */
    getCategory(options) {
        return getWorkflowStatusCategoryFn(this.getOptions(options));
    }
}
class UserGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Search = new UserSearchGroup(connection, options);
    }
    /**
     * Returns a user.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-getUser
     * @param options Request options.
     */
    getUser(options) {
        return getUserFn(this.getOptions(options));
    }
    /**
     * Modify user. The "value" fields present will override the existing value. Fields skipped in request will not be changed.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-updateUser
     * @param options Request options.
     */
    updateUser(options) {
        return updateUserFn(this.getOptions(options));
    }
    /**
     * Create user. By default created user will not be notified with email. If password field is not set then password will be randomly generated.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-createUser
     * @param options Request options.
     */
    createUser(options) {
        return createUserFn(this.getOptions(options));
    }
    /**
     * Removes user and its references (like project roles associations, watches, history).
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-removeUser
     * @param options Request options.
     */
    removeUser(options) {
        return removeUserFn(this.getOptions(options));
    }
    /**
     * Add user to given application. Admin permission will be required to perform this operation.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-addUserToApplication
     * @param options Request options.
     */
    addUserToApplication(options) {
        return addUserToApplicationFn(this.getOptions(options));
    }
    /**
     * Remove user from given application. Admin permission will be required to perform this operation.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-removeUserFromApplication
     * @param options Request options.
     */
    removeUserFromApplication(options) {
        return removeUserFromApplicationFn(this.getOptions(options));
    }
    /**
     * Modify user password.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-changeUserPassword
     * @param options Request options.
     */
    changeUserPassword(options) {
        return changeUserPasswordFn(this.getOptions(options));
    }
}
class UserSearchGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of users that match the search string. This resource cannot be accessed anonymously. Please note that this resource should be called with an issue key when a list of assignable users is retrieved for editing. For create only a project key should be supplied. The list of assignable users may be incorrect if it's called with the project key for editing.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findAssignableUsers
     * @param options Request options.
     */
    findAssignableUsers(options) {
        return findAssignableUsersFn(this.getOptions(options));
    }
    /**
     * Returns a list of active users that match the search string and have all specified permissions for the project or issue.
     * This resource can be accessed by users with ADMINISTER_PROJECT permission for the project or global ADMIN or SYSADMIN rights.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findUsersWithAllPermissions
     * @param options Request options.
     */
    findUsersWithAllPermissions(options) {
        return findUsersWithAllPermissionsFn(this.getOptions(options));
    }
    /**
     * Returns a list of users that match the search string. This resource cannot be accessed anonymously.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findUsers
     * @param options Request options.
     */
    findUsers(options) {
        return findUsersFn(this.getOptions(options));
    }
    /**
     * Returns a list of active users that match the search string. This resource cannot be accessed anonymously and requires the Browse Users global permission. Given an issue key this resource will provide a list of users that match the search string and have the browse issue permission for the issue provided.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/user-findUsersWithBrowsePermission
     * @param options Request options.
     */
    findUsersWithBrowsePermission(options) {
        return findUsersWithBrowsePermissionFn(this.getOptions(options));
    }
}
class ProjectVersionGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Count = new VersionCountGroup(connection, options);
    }
    /**
     * Create a version via POST.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-createVersion
     * @param options Request options.
     */
    createVersion(options) {
        return createProjectVersionFn(this.getOptions(options));
    }
    /**
     * Modify a version's sequence within a project.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-moveVersion
     * @param options Request options.
     */
    moveVersion(options) {
        return moveProjectVersionFn(this.getOptions(options));
    }
    /**
     * Returns a project version.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersion
     * @param options Request options.
     */
    getVersion(options) {
        return getProjectVersionFn(this.getOptions(options));
    }
    /**
     * Modify a version via PUT. Any fields present in the PUT will override existing values. As a convenience, if a field is not present, it is silently ignored.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-updateVersion
     * @param options Request options.
     */
    updateVersion(options) {
        return updateProjectVersionFn(this.getOptions(options));
    }
    /**
     * Delete a project version.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
     * @param options Request options.
     */
    deleteVersion(options) {
        return deleteProjectVersionFn(this.getOptions(options));
    }
    /**
     * Merge versions.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-merge
     * @param options Request options.
     */
    mergeVersion(options) {
        return mergeProjectVersionFn(this.getOptions(options));
    }
    /**
     * Delete a project version.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
     * @param options Request options.
     */
    removeAndReplaceVersion(options) {
        return removeAndReplaceProjectVersionFn(this.getOptions(options));
    }
}
class VersionCountGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a bean containing the number of fixed in and affected issues for the given version.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionRelatedIssues
     * @param options Request options.
     */
    getVersionRelatedIssueCount(options) {
        return getProjectVersionRelatedIssueCountFn(this.getOptions(options));
    }
    /**
     * Returns the number of unresolved issues for the given version
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionUnresolvedIssues
     * @param options Request options.
     */
    getVersionUnresolvedIssueCount(options) {
        return getProjectVersionUnresolvedIssueCountFn(this.getOptions(options));
    }
}
class RoleGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Project = new RoleProjectGroup(connection, options);
    }
}
class RoleProjectGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Get all the ProjectRoles available in JIRA. Currently this list is global.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRoles
     * @param options Request options.
     */
    getRoles(options) {
        return getGlobalProjectRolesFn(this.getOptions(options));
    }
    /**
     * Get a specific ProjectRole available in JIRA.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRolesById
     * @param options Request options.
     */
    getRole(options) {
        return getGlobalProjectRoleFn(this.getOptions(options));
    }
}
class PermissionGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns all permissions that are present in the JIRA instance - Global, Project and the global ones added by plugins
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getAllPermissions
     * @param options Request options.
     */
    getPermissions(options) {
        return getPermissionsFn(this.getOptions(options));
    }
    /**
     * Returns all permissions in the system and whether the currently logged in user has them.
     * You can optionally provide a specific context to get permissions for (projectKey OR projectId OR issueKey OR issueId).
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getPermissions
     * @param options Request options.
     */
    getMyPermissions(options) {
        return getMyPermissionsFn(this.getOptions(options));
    }
}
class DashboardGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a list of all dashboards, optionally filtering them.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-list
     * @param options Request options.
     */
    getDashboards(options) {
        return getAllDashboardsFn(this.getOptions(options));
    }
    /**
     * Returns a single dashboard.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-getDashboard
     * @param options Request options.
     */
    getDashboard(options) {
        return getDashboardByIdFn(this.getOptions(options));
    }
}
class SharePermissionGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns all share permissions of the given filter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermissions
     * @param options Request options.
     */
    getSharePermissions(options) {
        return getFilterSharePermissionsFn(this.getOptions(options));
    }
    /**
     * Adds a share permissions to the given filter. Adding a global permission removes all previous permissions from the filter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-addSharePermission
     * @param options Request options.
     */
    addSharePermission(options) {
        return addFilterSharePermissionFn(this.getOptions(options));
    }
    /**
     * Returns a single share permission of the given filter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
     * @param options Request options.
     */
    getSharePermission(options) {
        return getFilterSharePermissionFn(this.getOptions(options));
    }
    /**
     * Removes a share permissions from the given filter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
     * @param options Request options.
     */
    deleteSharePermission(options) {
        return deleteFilterSharePermissionFn(this.getOptions(options));
    }
}
class SchemeGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Notification = new SchemeNotificationGroup(connection, options);
    }
}
class SchemeNotificationGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns a paginated list of notification schemes.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/notificationscheme-getNotificationSchemes
     * @param options Request options.
     */
    getSchemes(options) {
        return getNotificationSchemesFn(this.getOptions(options));
    }
}
class FilterColumnGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
    }
    /**
     * Returns the default columns for the given filter. Currently logged in user will be used as the user making such request.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-defaultColumns
     * @param options Request options.
     */
    getDefaultColumns(options) {
        return getFilterDefaultColumnsFn(this.getOptions(options));
    }
    /**
     * Sets the default columns for the given filter.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setColumns
     * @param options Request options.
     */
    setDefaultColumns(options) {
        return setFilterDefaultColumnsFn(this.getOptions(options));
    }
    /**
     * Resets the columns for the given filter such that the filter no longer has its own column config.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-resetColumns
     * @param options Request options.
     */
    resetColumns(options) {
        return resetFilterColumnsFn(this.getOptions(options));
    }
}
class FilterShareGroup extends BaseGroup {
    constructor(connection, options) {
        super(connection, options);
        this.Permission = new SharePermissionGroup(connection, options);
    }
    /**
     * Returns the default share scope of the logged-in user.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getDefaultShareScope
     * @param options Request options.
     */
    getShareScope(options) {
        return getDefaultShareScopeFn(this.getOptions(options));
    }
    /**
     * Sets the default share scope of the logged-in user. Available values are GLOBAL and PRIVATE.
     * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setDefaultShareScope
     * @param options Request options.
     */
    setShareScope(options) {
        return setDefaultShareScopeFn(this.getOptions(options));
    }
}
