import { looksLikeNumber, performHttpCall } from '@avst-api/commons';
;
;
;
;
;
;
const addSpecialHeaders = (headers) => {
    return {
        ...headers,
        'X-Atlassian-Token': 'no-check'
    };
};
export function httpGet(connection, urlPath, headers, skipBodyParsing = false) {
    return performHttpCall(connection, urlPath, 'GET', undefined, addSpecialHeaders(headers), skipBodyParsing);
}
export async function httpPost(connection, urlPath, request, headers, skipBodyParsing = false) {
    const req = await resolveAsyncBody(request);
    return performHttpCall(connection, urlPath, 'POST', req, addSpecialHeaders(headers), skipBodyParsing);
}
export async function httpPut(connection, urlPath, request, headers, skipBodyParsing = false) {
    const req = await resolveAsyncBody(request);
    return performHttpCall(connection, urlPath, 'PUT', req, addSpecialHeaders(headers), skipBodyParsing);
}
export function httpDelete(connection, urlPath, headers, skipBodyParsing = false) {
    return performHttpCall(connection, urlPath, 'DELETE', undefined, addSpecialHeaders(headers), skipBodyParsing);
}
export function getFields(fields, customFieldIdOrName) {
    customFieldIdOrName = customFieldIdOrName.toString().trim();
    if (looksLikeNumber(customFieldIdOrName)) {
        return fields.filter(field => field.id === `customfield_${customFieldIdOrName}`);
    }
    else if (customFieldIdOrName.match(/^customfield_\d+$/)) {
        return fields.filter(field => field.id === customFieldIdOrName);
    }
    else {
        return fields.filter(field => field.name.toLowerCase() === customFieldIdOrName.toString().trim().toLowerCase());
    }
}
async function resolveAsyncBody(request) {
    if (request && request.body && request.body instanceof Promise) {
        const value = await request.body;
        request.body = value;
        return request;
    }
    else {
        return request;
    }
}
