import { Dashboard } from '../types/dashboard';
/**
 * Returns a list of all dashboards, optionally filtering them.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-list
 * @param options Request options.
 */
export declare function getAllDashboards(options: Dashboard.GetDashboards.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/dashboard").Dashboards | undefined>>;
/**
 * Returns a single dashboard.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-getDashboard
 * @param options Request options.
 */
export declare function getDashboardById(options: Dashboard.GetDashboard.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/dashboard").Dashboard | undefined>>;
//# sourceMappingURL=dashboard.d.ts.map