import { Filter } from '../types/filter';
/**
 * Returns a filter given an id.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFilter
 * @param options Request options.
 */
export declare function getFilter(options: Filter.GetFilter.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/filter").Filter | undefined>>;
/**
 * Returns the favourite filters of the logged-in user.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFavouriteFilters
 * @param options Request options.
 */
export declare function getMyFavouriteFilters(options: Filter.GetMyFavouriteFilters.Options.RawApi): Promise<import("@avst-api/commons").Response<Filter.GetMyFavouriteFilters.Response.OK | undefined>>;
/**
 * Creates a new filter, and returns newly created filter. Currently sets permissions just using the users default sharing permissions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-createFilter
 * @param options Request options.
 */
export declare function createFilter(options: Filter.CreateFilter.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/filter").Filter | undefined>>;
/**
 * Updates an existing filter, and returns its new value.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-editFilter
 * @param options Request options.
 */
export declare function editFilter(options: Filter.EditFilter.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/filter").Filter | undefined>>;
/**
 * Delete a filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-deleteFilter
 * @param options Request options.
 */
export declare function deleteFilter(options: Filter.DeleteFilter.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=filter.d.ts.map