import { Filter } from '../../types/filter';
/**
 * Returns the default columns for the given filter. Currently logged in user will be used as the user making such request.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-defaultColumns
 * @param options Request options.
 */
export declare function getFilterDefaultColumns(options: Filter.Column.GetDefaultColumns.Options.RawApi): Promise<import("@avst-api/commons").Response<Filter.Column.GetDefaultColumns.Response.OK | undefined>>;
/**
 * Sets the default columns for the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setColumns
 * @param options Request options.
 */
export declare function setFilterDefaultColumns(options: Filter.Column.SetDefaultColumns.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Resets the columns for the given filter such that the filter no longer has its own column config.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-resetColumns
 * @param options Request options.
 */
export declare function resetFilterColumns(options: Filter.Column.ResetColumns.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=column.d.ts.map