import { Filter } from '../../types/filter';
/**
 * Returns the default share scope of the logged-in user.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getDefaultShareScope
 * @param options Request options.
 */
export declare function getDefaultShareScope(options: Filter.Share.GetDefaultScope.Options.RawApi): Promise<import("@avst-api/commons").Response<Filter.Share.GetDefaultScope.Response.OK | undefined>>;
/**
 * Sets the default share scope of the logged-in user. Available values are GLOBAL and PRIVATE.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setDefaultShareScope
 * @param options Request options.
 */
export declare function setDefaultShareScope(options: Filter.Share.SetDefaultScope.Options.RawApi): Promise<import("@avst-api/commons").Response<Filter.Share.SetDefaultScope.Response.OK | undefined>>;
//# sourceMappingURL=share.d.ts.map