import { Filter } from '../../../types/filter';
/**
 * Returns all share permissions of the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermissions
 * @param options Request options.
 */
export declare function getFilterSharePermissions(options: Filter.Share.Permission.GetSharePermissions.Options.RawApi): Promise<import("@avst-api/commons").Response<Filter.Share.Permission.GetSharePermissions.Response.OK | undefined>>;
/**
 * Adds a share permissions to the given filter. Adding a global permission removes all previous permissions from the filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-addSharePermission
 * @param options Request options.
 */
export declare function addFilterSharePermission(options: Filter.Share.Permission.AddSharePermissions.Options.RawApi): Promise<import("@avst-api/commons").Response<Filter.Share.Permission.AddSharePermissions.Response.OK | undefined>>;
/**
 * Returns a single share permission of the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
 * @param options Request options.
 */
export declare function getFilterSharePermission(options: Filter.Share.Permission.GetSharePermission.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../../definitions/filter").FilterPermission | undefined>>;
/**
 * Removes a share permissions from the given filter.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission
 * @param options Request options.
 */
export declare function deleteFilterSharePermission(options: Filter.Share.Permission.DeleteSharePermission.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=permission.d.ts.map