import { Group } from '../../types/group';
/**
 * This resource returns a paginated list of users who are members of the specified group and its subgroups. Users in the page are ordered by user names. User of this resource is required to have sysadmin or admin permissions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-getUsersFromGroup
 * @param options Request options.
 */
export declare function getUsersFromGroup(options: Group.User.GetUsers.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/group").GetUsersResponse | undefined>>;
/**
 * Adds given user to a group.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-addUserToGroup
 * @param options Request options.
 */
export declare function addUsersToGroup(options: Group.User.AddUsers.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/group").GroupResponse | undefined>>;
/**
 * Removes given user from a group.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/group-removeUserFromGroup
 * @param options Request options.
 */
export declare function removeUsersFromGroup(options: Group.User.RemoveUsers.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=user.d.ts.map