import { Issue } from '../../types/issue';
/**
 * Returns the meta-data for an attachment, including the URI of the actual attached file.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-getAttachment
 * @param options Request options.
 */
export declare function getIssueAttachment(options: Issue.Attachment.GetAttachment.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/attachment").Attachment | undefined>>;
/**
 * Remove an attachment from an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/attachment-removeAttachment
 * @param options Request options.
 */
export declare function removeIssueAttachment(options: Issue.Attachment.RemoveAttachment.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Add one or more attachments to an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/attachments-addAttachment
 * @param options Request options.
 */
export declare function addIssueAttachment(options: Issue.Attachment.AddAttachment.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.Attachment.AddAttachment.Response.OK | undefined>>;
//# sourceMappingURL=attachment.d.ts.map