import { Issue } from '../../types/issue';
/**
 * Returns all comments for an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComments
 * @param options Request options.
 */
export declare function getIssueComments(options: Issue.Comment.GetComments.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.Comment.GetComments.Response.OK | undefined>>;
/**
 * Adds a new comment to an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addComment
 * @param options Request options.
 */
export declare function addIssueComment(options: Issue.Comment.AddComment.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/comment").Comment | undefined>>;
/**
 * Returns a single comment.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getComment
 * @param options Request options.
 */
export declare function getIssueComment(options: Issue.Comment.GetComment.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/comment").Comment | undefined>>;
/**
 * Updates an existing comment using its JSON representation.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-updateComment
 * @param options Request options.
 */
export declare function updateIssueComment(options: Issue.Comment.UpdateComment.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/comment").Comment | undefined>>;
/**
 * Deletes an existing comment.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-deleteComment
 * @param options Request options.
 */
export declare function deleteIssueComment(options: Issue.Comment.DeleteComment.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=comment.d.ts.map