import { httpGet } from '../common';
/**
 * Returns a list of all fields, both System and Custom.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/field-getFields
 * @param options Request options.
 */
export function getIssueFields(options) {
    const { connectionId: instanceId, headers } = options;
    return httpGet(instanceId, '/rest/api/2/field', headers);
}
