import { httpGet } from '../../common';
import { constructUrl } from '@avst-api/commons';
/**
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFields-getCustomFields
 * @param options Request options.
 */
export function getIssueCustomFields(options) {
    const { connectionId: instanceId, headers, maxResults, startAt, search } = options;
    const queryParams = { maxResults, startAt, search };
    return httpGet(instanceId, constructUrl('/rest/api/2/customFields', queryParams), headers);
}
