import { httpGet } from '../../../common';
/**
 * Returns a full representation of the Custom Field Option that has the given id.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/customFieldOption-getCustomFieldOption
 * @param options Request options.
 */
export function getIssueCustomFieldOption(options) {
    const { connectionId: instanceId, id, headers } = options;
    return httpGet(instanceId, `/rest/api/2/customFieldOption/${id}`, headers);
}
