import { Issue } from '../../types/issue';
/**
 * Returns a list of all issue priorities.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriorities
 * @param options Request options.
 */
export declare function getIssuePriorities(options: Issue.Priority.GetPriorities.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.Priority.GetPriorities.Response.OK | undefined>>;
/**
 * Returns an issue priority.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriority
 * @param options Request options.
 */
export declare function getIssuePriority(options: Issue.Priority.GetPriority.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/priority").Priority | undefined>>;
//# sourceMappingURL=priority.d.ts.map