import { httpGet } from '../common';
/**
 * Returns a list of all issue priorities.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriorities
 * @param options Request options.
 */
export function getIssuePriorities(options) {
    const { connectionId: instanceId, headers } = options;
    return httpGet(instanceId, '/rest/api/2/priority', headers);
}
/**
 * Returns an issue priority.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/priority-getPriority
 * @param options Request options.
 */
export function getIssuePriority(options) {
    const { connectionId: instanceId, id, headers } = options;
    return httpGet(instanceId, `/rest/api/2/priority/${id}`, headers);
}
