import { Issue } from '../../types/issue';
/**
 * Returns a list of all resolutions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolutions
 * @param options Request options.
 */
export declare function getIssueResolutions(options: Issue.Resolution.GetResolutions.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.Resolution.GetResolutions.Response.OK | undefined>>;
/**
 * Returns a resolution.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolution
 * @param options Request options.
 */
export declare function getIssueResolution(options: Issue.Resolution.GetResolution.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/resolution").Resolution | undefined>>;
//# sourceMappingURL=resolution.d.ts.map