import { httpGet } from '../common';
/**
 * Returns a list of all resolutions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolutions
 * @param options Request options.
 */
export function getIssueResolutions(options) {
    const { connectionId: instanceId, headers } = options;
    return httpGet(instanceId, '/rest/api/2/resolution', headers);
}
/**
 * Returns a resolution.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/resolution-getResolution
 * @param options Request options.
 */
export function getIssueResolution(options) {
    const { connectionId: instanceId, id, headers } = options;
    return httpGet(instanceId, `/rest/api/2/resolution/${id}`, headers);
}
