import { httpPost } from '../common';
/**
 * Performs a search using JQL.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/search-searchUsingSearchRequest
 * @param options Request options.
 */
export function searchIssuesByJql(options) {
    const { connectionId: instanceId, body, headers } = options;
    return httpPost(instanceId, '/rest/api/2/search', body, headers);
}
