import { Issue } from '../../types/issue';
/**
 * Returns an issue's subtask list.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-getSubTasks
 * @param options Request options.
 */
export declare function getIssueSubTasks(options: Issue.SubTask.GetSubTasks.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.SubTask.GetSubTasks.Response.OK | undefined>>;
/**
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-canMoveSubTask
 * @param options Request options.
 */
export declare function canMoveIssueSubTask(options: Issue.SubTask.CanMoveSubTask.Options.RawApi): Promise<import("@avst-api/commons").Response<boolean | undefined>>;
/**
 * Reorders an issue's subtasks by moving the subtask at index "from" to index "to".
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue/{issueIdOrKey}/subtask-moveSubTasks
 * @param options Request options.
 */
export declare function moveIssueSubTasks(options: Issue.SubTask.MoveSubTasks.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=subTask.d.ts.map