import { Issue } from '../../types/issue';
/**
 * Remove your vote from an issue. (i.e. "unvote").
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeVote
 * @param options Request options.
 */
export declare function removeIssueVote(options: Issue.Vote.RemoveVote.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Cast your vote in favour of an issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addVote
 * @param options Request options.
 */
export declare function addIssueVote(options: Issue.Vote.AddVote.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * A REST sub-resource representing the voters on the issue.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getVotes
 * @param options Request options.
 */
export declare function getIssueVotes(options: Issue.Vote.GetVotes.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.Vote.GetVotes.Response.OK | undefined>>;
//# sourceMappingURL=vote.d.ts.map