import { Issue } from '../../types/issue';
/**
 * Returns the list of watchers for the issue with the given key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-getIssueWatchers
 * @param options Request options.
 */
export declare function getIssueWatchers(options: Issue.Watcher.GetWatchers.Options.RawApi): Promise<import("@avst-api/commons").Response<Issue.Watcher.GetWatchers.Response.OK | undefined>>;
/**
 * Adds a user to an issue's watcher list.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-addWatcher
 * @param options Request options.
 */
export declare function addIssueWatcher(options: Issue.Watcher.AddWatcher.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Removes a user from an issue's watcher list.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issue-removeWatcher
 * @param options Request options.
 */
export declare function removeIssueWatcher(options: Issue.Watcher.RemoveWatcher.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=watcher.d.ts.map