import { httpGet } from './common';
/**
 * Returns currently logged in user.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/myself-getUser
 * @param options Request options.
 */
export function getCurrentUser(options) {
    const { connectionId: instanceId, headers } = options;
    return httpGet(instanceId, '/rest/api/2/myself', headers);
}
