import { Permission } from '../types/permission';
/**
 * Returns all permissions that are present in the JIRA instance - Global, Project and the global ones added by plugins
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getAllPermissions
 * @param options Request options.
 */
export declare function getPermissions(options: Permission.GetPermissions.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/permissions").Permissions | undefined>>;
/**
 * Returns all permissions in the system and whether the currently logged in user has them.
 * You can optionally provide a specific context to get permissions for (projectKey OR projectId OR issueKey OR issueId)
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getPermissions
 * @param options Request options.
 */
export declare function getMyPermissions(options: Permission.GetMyPermissions.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../definitions/permissions").Permissions | undefined>>;
//# sourceMappingURL=permission.d.ts.map