import { Project } from '../../types/project';
/**
 * Create a component via POST.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-createComponent
 * @param options Request options.
 */
export declare function createProjectComponent(options: Project.Component.CreateComponent.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/component").Component | undefined>>;
/**
 * Returns a project component.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponent
 * @param options Request options.
 */
export declare function getProjectComponent(options: Project.Component.GetComponent.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/component").Component | undefined>>;
/**
 * Modify a component via PUT. If leadUserName is an empty string ("") the component lead will be removed.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-updateComponent
 * @param options Request options.
 */
export declare function updateProjectComponent(options: Project.Component.UpdateComponent.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/component").Component | undefined>>;
/**
 * Delete a project component.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-delete
 * @param options Request options.
 */
export declare function deleteProjectComponent(options: Project.Component.DeleteComponent.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Returns counts of issues related to this component.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/component-getComponentRelatedIssues
 * @param options Request options.
 */
export declare function getProjectComponentRelatedIssues(options: Project.Component.GetRelatedIssues.Options.RawApi): Promise<import("@avst-api/commons").Response<Project.Component.GetRelatedIssues.Response.OK | undefined>>;
//# sourceMappingURL=component.d.ts.map