import { Project } from '../../types/project';
/**
 * Returns all roles in the given project Id or key, with links to full details on each role.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRoles
 * @param options Request options.
 */
export declare function getProjectRoles(options: Project.Role.GetRoles.Options.RawApi): Promise<import("@avst-api/commons").Response<Record<string, string> | undefined>>;
/**
 * Returns the details for a given project role in a project.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-getProjectRole
 * @param options Request options.
 */
export declare function getProjectRole(options: Project.Role.GetRole.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/project_role").ProjectRole | undefined>>;
//# sourceMappingURL=role.d.ts.map