import { Project } from '../../../types/project';
/**
 * Updates a project role to include the specified actors (users or groups).
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-setActors
 * @param options Request options.
 */
export declare function setProjectRoleActors(options: Project.Role.Actor.SetActors.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../../definitions/project_role").ProjectRole | undefined>>;
/**
 * Adds an actor (user or group) to a project role.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-addActorUsers
 * @param options Request options.
 */
export declare function addProjectRoleActorUsers(options: Project.Role.Actor.AddUsers.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../../definitions/project_role").ProjectRole | undefined>>;
/**
 * Deletes actors (users or groups) from a project role.
 * Delete a user from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?user={username}
 * Delete a group from the role: /rest/api/2/project/{projectIdOrKey}/role/{roleId}?group={groupname}
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/{projectIdOrKey}/role-deleteActor
 * @param options Request options.
 */
export declare function deleteProjectRoleActor(options: Project.Role.Actor.DeleteActor.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=actor.d.ts.map