import { Project } from '../../types/project';
/**
 * Returns all the project types defined on the JIRA instance, not taking into account whether the license to use those project types is valid or not.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getAllProjectTypes
 * @param options Request options.
 */
export declare function getProjectTypes(options: Project.Type.GetTypes.Options.RawApi): Promise<import("@avst-api/commons").Response<Project.Type.GetTypes.Response.OK | undefined>>;
/**
 * Returns the project type with the given key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getProjectTypeByKey
 * @param options Request options.
 */
export declare function getProjectType(options: Project.Type.GetType.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/project_type").ProjectType | undefined>>;
/**
 * Returns the project type with the given key, if it is accessible to the logged in user. This takes into account whether the user is licensed on the Application that defines the project type.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/project/type-getAccessibleProjectTypeByKey
 * @param options Request options.
 */
export declare function getAccessibleProjectType(options: Project.Type.GetAccessibleType.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/project_type").ProjectType | undefined>>;
//# sourceMappingURL=type.d.ts.map