import { httpGet } from '../common';
import { constructUrl } from '@avst-api/commons';
/**
 * Validates a project key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/projectvalidate-getProject
 * @param options Request options.
 */
export function validateProjectKey(options) {
    const { connectionId: instanceId, headers, key } = options;
    const queryParams = { key };
    return httpGet(instanceId, constructUrl('/rest/api/2/projectvalidate/key', queryParams), headers);
}
