import { Project } from '../../types/project';
/**
 * Create a version via POST.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-createVersion
 * @param options Request options.
 */
export declare function createProjectVersion(options: Project.Version.CreateVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/version").Version | undefined>>;
/**
 * Modify a version's sequence within a project.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-moveVersion
 * @param options Request options.
 */
export declare function moveProjectVersion(options: Project.Version.MoveVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/version").Version | undefined>>;
/**
 * Returns a project version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersion
 * @param options Request options.
 */
export declare function getProjectVersion(options: Project.Version.GetVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/version").Version | undefined>>;
/**
 * Modify a version via PUT. Any fields present in the PUT will override existing values. As a convenience, if a field is not present, it is silently ignored.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-updateVersion
 * @param options Request options.
 */
export declare function updateProjectVersion(options: Project.Version.UpdateVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/version").Version | undefined>>;
/**
 * Delete a project version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
 * @param options Request options.
 */
export declare function deleteProjectVersion(options: Project.Version.DeleteVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Merge versions.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-merge
 * @param options Request options.
 */
export declare function mergeProjectVersion(options: Project.Version.MergeVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
/**
 * Delete a project version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-delete
 * @param options Request options.
 */
export declare function removeAndReplaceProjectVersion(options: Project.Version.RemoveAndReplaceVersion.Options.RawApi): Promise<import("@avst-api/commons").Response<undefined>>;
//# sourceMappingURL=version.d.ts.map