import { Project } from '../../../types/project';
/**
 * Returns a bean containing the number of fixed in and affected issues for the given version.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionRelatedIssues
 * @param options Request options.
 */
export declare function getProjectVersionRelatedIssueCount(options: Project.Version.Count.GetVersionRelatedIssueCount.Options.RawApi): Promise<import("@avst-api/commons").Response<Project.Version.Count.GetVersionRelatedIssueCount.Response.OK | undefined>>;
/**
 * Returns the number of unresolved issues for the given version
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/version-getVersionUnresolvedIssues
 * @param options Request options.
 */
export declare function getProjectVersionUnresolvedIssueCount(options: Project.Version.Count.GetVersionUnresolvedIssueCount.Options.RawApi): Promise<import("@avst-api/commons").Response<Project.Version.Count.GetVersionUnresolvedIssueCount.Response.OK | undefined>>;
//# sourceMappingURL=count.d.ts.map