import { Role } from '../../types/role';
/**
 * Get all the ProjectRoles available in JIRA. Currently this list is global.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRoles
 * @param options Request options.
 */
export declare function getGlobalProjectRoles(options: Role.Project.GetRoles.Options.RawApi): Promise<import("@avst-api/commons").Response<Role.Project.GetRoles.Response.OK | undefined>>;
/**
 * Get a specific ProjectRole available in JIRA.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRolesById
 * @param options Request options.
 */
export declare function getGlobalProjectRole(options: Role.Project.GetRole.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/project_role").ProjectRole | undefined>>;
//# sourceMappingURL=project.d.ts.map