import { httpGet } from '../common';
/**
 * Get all the ProjectRoles available in JIRA. Currently this list is global.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRoles
 * @param options Request options.
 */
export function getGlobalProjectRoles(options) {
    const { connectionId: instanceId, headers } = options;
    return httpGet(instanceId, '/rest/api/2/role', headers);
}
/**
 * Get a specific ProjectRole available in JIRA.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/role-getProjectRolesById
 * @param options Request options.
 */
export function getGlobalProjectRole(options) {
    const { connectionId: instanceId, id, headers } = options;
    return httpGet(instanceId, `/rest/api/2/role/${id}`, headers);
}
