import { httpGet } from '../common';
import { constructUrl } from '@avst-api/commons';
/**
 * Returns a paginated list of notification schemes.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/notificationscheme-getNotificationSchemes
 * @param options Request options.
 */
export function getNotificationSchemes(options) {
    const { connectionId: instanceId, headers, startAt, maxResults, expand } = options;
    const queryParams = { startAt, maxResults, expand };
    return httpGet(instanceId, constructUrl('/rest/api/2/notificationscheme', queryParams), headers);
}
