import { constructUrl } from '@avst-api/commons';
import { httpGet } from './common';
/**
 * Returns all workflows.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/workflow-getAllWorkflows
 * @param options Request options.
 */
export function getWorkflows(options) {
    const { connectionId: instanceId, headers, workflowName } = options;
    const queryParams = { workflowName };
    return httpGet(instanceId, constructUrl('/rest/api/2/workflow', queryParams), headers);
}
