import { Workflow } from '../../types/workflow';
/**
 * Returns a list of all statuses.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatuses
 * @param options Request options.
 */
export declare function getWorkflowStatuses(options: Workflow.Status.GetStatuses.Options.RawApi): Promise<import("@avst-api/commons").Response<Workflow.Status.GetStatuses.Response.OK | undefined>>;
/**
 * Returns a full representation of the Status having the given id or name.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/status-getStatus
 * @param options Request options.
 */
export declare function getWorkflowStatus(options: Workflow.Status.GetStatus.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../definitions/status").Status | undefined>>;
//# sourceMappingURL=status.d.ts.map