import { Workflow } from '../../../types/workflow';
/**
 * Returns a list of all status categories.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategories
 * @param options Request options.
 */
export declare function getWorkflowStatusCategories(options: Workflow.Status.Category.GetCategories.Options.RawApi): Promise<import("@avst-api/commons").Response<Workflow.Status.Category.GetCategories.Response.OK | undefined>>;
/**
 * Returns a full representation of the StatusCategory having the given id or key.
 * Documentation: https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/statuscategory-getStatusCategory
 * @param options Request options.
 */
export declare function getWorkflowStatusCategory(options: Workflow.Status.Category.GetCategory.Options.RawApi): Promise<import("@avst-api/commons").Response<import("../../../definitions/status_category").StatusCategory | undefined>>;
//# sourceMappingURL=category.d.ts.map