# 0.5.0

- Added support for the following Issue Link Type methods:

  * [Create issue link type](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-createIssueLinkType) that can be used as `Issue.Link.Type.createType` or `All.createIssueLinkType`.
  * [Delete issue link type](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-deleteIssueLinkType) that can be used as `Issue.Link.Type.deleteType` or `All.deleteIssueLinkType`.  
  * [Update issue link type](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issueLinkType-updateIssueLinkType) that can be used as `Issue.Link.Type.updateType` or `All.updateIssueLinkType`.

- Added support for the following Issue Type methods:

  * [Create issue type](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-createIssueType) that can be used as `Issue.Type.createType` or `All.createIssueType`.  
  * [Delete issue type](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-deleteIssueType) that can be used as `Issue.Type.deleteType` or `All.deleteIssueType`.  
  * [Update issue type](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-updateIssueType) that can be used as `Issue.Type.updateType` or `All.updateIssueType`. 
  * [Get alternative issue types](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/issuetype-getAlternativeIssueTypes) that can be used as `Issue.Type.getAlternativeTypes` or `All.getAlternativeIssueTypes`.        

# 0.4.0

- Added support for the following Filter methods:

  * [Create filter](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-createFilter) that can be used as `Filter.createFilter` or `All.createFilter`.
  * [Edit filter](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-editFilter) that can be used as `Filter.editFilter` or `All.editFilter`.  
  * [Delete filter](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-deleteFilter) that can be used as `Filter.deleteFilter` or `All.deleteFilter`.

- Added support for the following Filter Column methods:

  * [Default columns](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-defaultColumns) that can be used as `Filter.Column.getDefaultColumns` or `All.getFilterDefaultColumns`. 
  * [Set columns](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setColumns) that can be used as `Filter.Column.setDefaultColumns` or `All.setFilterDefaultColumns`. 
  * [Reset columns](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-resetColumns) that can be used as `Filter.Column.resetColumns` or `All.resetFilterColumns`. 

- Added support for the following Filter Share methods:

  * [Get default share scope](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getDefaultShareScope) that can be used as `Filter.Share.getShareScope` or `All.getDefaultShareScope`.
  * [Set default share scope](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-setDefaultShareScope) that can be used as `Filter.Share.setShareScope` or `All.setDefaultShareScope`.

- Added support for the following Filter Share Permission methods:

  * [Get share permissions](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermissions) that can be used as `Filter.Share.Permission.getSharePermissions` or `All.getFilterSharePermissions`.
  * [Add share permission](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-addSharePermission) that can be used as `Filter.Share.Permission.addSharePermission` or `All.addFilterSharePermission`.
  * [Get share permission](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getSharePermission) that can be used as `Filter.Share.Permission.getSharePermission` or `All.getFilterSharePermission`. 
  * [Delete share permission](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-deleteSharePermission) that can be used as `Filter.Share.Permission.deleteSharePermission` or `All.deleteFilterSharePermission`. 

# 0.3.0

- Added support for the following Permission methods:

  * [Get permissions](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getPermissions) that can be used as `Permission.getMyPermissions` or `All.getMyPermissions`.
  * [Get all permissions](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/-getAllPermissions) that can be used as `Permission.getPermissions` or `All.getPermissions`.  

- Added support for the following Dashboard methods:

  * [Dashboard List](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-list) that can be used as `Dashboard.getDashboards` or `All.getAllDashboards`.  
  * [Get dashboard](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/dashboard-getDashboard) that can be used as `Dashboard.getDashboard` or `All.getDashboardById`. 

- Added support for the following Filter methods:

  * [Get favourite filters](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/filter-getFavouriteFilters) that can be used as `Filter.getMyFavouriteFilters` or `All.getMyFavouriteFilters`.

- Added support for the following Scheme methods:

  * [Get notification schemes](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/notificationscheme-getNotificationSchemes) that can be used as `Scheme.Notification.getSchemes` or `All.getNotificationSchemes`.

- Added support for the following Workflow methods:

  * [Get all workflows](https://docs.atlassian.com/software/jira/docs/api/REST/7.13.9/#api/2/workflow-getAllWorkflows) that can be used as `Workflow.getWorkflows` or `All.getWorkflows`.

# 0.2.0

- Added `IssueBuilder` abstraction for creating issue body object for `createIssue` and `editIssue` methods.
- Added `CustomFieldReader` abstraction for reading custom fields and its values.

# 0.1.12

- Added `X-Atlassian-Token: no-check` header for adding attachments to issues request.

# 0.1.11

- Added `reporter` property for creating or editing issue requests.

# 0.1.10

- Removed `io-ts` and `fp-ts` packages.

# 0.1.9

- Removed ADF from creating issue request.

# 0.1.8

- Fixed `setGlobalErrorStrategy` method.

# 0.1.7

- Added `setGlobalErrorStrategy` method to allow another way to set the global error strategy.
- Renamed `connection` property to `connectionId` in `raw-api` and `handled-api` layers.
- Removed `AnyError` and `ValidationError` from `TypedPromise` return signature.

# 0.1.6
 
- Renamed abstraction layers:
    * From <b>http-api</b> to <b>raw-api</b>
    * From <b>managed-api</b> to <b>handled-api</b>
