import { ErrorStrategyOption, AssistedErrorStrategyOption } from '../handled-api/common';
import { HeadersOption, ConnectionOption } from '@avst-api/commons';
import { Dashboard, Dashboards } from '../definitions/dashboard';
export declare namespace Dashboard {
    namespace GetDashboards {
        interface Options extends Options.Base, HeadersOption, AssistedErrorStrategyOption {
        }
        namespace Response {
            type OK = Dashboards;
            type Error = undefined;
        }
        namespace Options {
            interface Base {
                filter?: 'favourite' | 'my';
                startAt?: number;
                maxResults?: number;
            }
            interface RawApi extends Base, ConnectionOption, HeadersOption {
            }
            interface HandledApi extends RawApi, ErrorStrategyOption {
            }
        }
    }
    namespace GetDashboard {
        interface Options extends Options.Base, HeadersOption, AssistedErrorStrategyOption {
        }
        namespace Response {
            type OK = Dashboard;
            type Error = undefined;
        }
        namespace Options {
            interface Base {
                id: string | number;
            }
            interface RawApi extends Base, ConnectionOption, HeadersOption {
            }
            interface HandledApi extends RawApi, ErrorStrategyOption {
            }
        }
    }
}
//# sourceMappingURL=dashboard.d.ts.map