import { ErrorStrategyOption, AssistedErrorStrategyOption } from '../handled-api/common';
import { HeadersOption, ConnectionOption } from '@avst-api/commons';
import { NotificationSchemeEvent } from '../definitions/notification';
export declare namespace Scheme {
    namespace Notification {
        namespace GetSchemes {
            interface Options extends Options.Base, HeadersOption, AssistedErrorStrategyOption {
            }
            namespace Response {
                type OK = {
                    self?: string;
                    nextPage?: string;
                    maxResults: number;
                    startAt: number;
                    total?: number;
                    isLast?: boolean;
                    values?: {
                        expand?: string;
                        id?: number;
                        self?: string;
                        name?: string;
                        description?: string;
                        notificationSchemeEvents: NotificationSchemeEvent[];
                    };
                };
                type Error = undefined;
            }
            namespace Options {
                interface Base {
                    startAt?: number;
                    maxResults?: number;
                    expand?: string;
                }
                interface RawApi extends Base, ConnectionOption, HeadersOption {
                }
                interface HandledApi extends RawApi, ErrorStrategyOption {
                }
            }
        }
    }
}
//# sourceMappingURL=scheme.d.ts.map