import { ErrorStrategyOption, AssistedErrorStrategyOption } from '../handled-api/common';
import { HeadersOption, ConnectionOption } from '@avst-api/commons';
import { Status } from '../definitions/status';
import { StatusCategory } from '../definitions/status_category';
import { Workflow } from '../definitions/workflow';
export declare namespace Workflow {
    namespace GetWorkflows {
        interface Options extends Options.Base, HeadersOption, AssistedErrorStrategyOption {
        }
        namespace Response {
            type OK = Workflow | Workflow[];
            type Error = undefined;
        }
        namespace Options {
            interface Base {
                workflowName: string;
            }
            interface RawApi extends Base, ConnectionOption, HeadersOption {
            }
            interface HandledApi extends RawApi, ErrorStrategyOption {
            }
        }
    }
    namespace Status {
        namespace GetStatuses {
            interface Options extends HeadersOption, AssistedErrorStrategyOption {
            }
            namespace Response {
                type OK = Status[];
                type Error = undefined;
            }
            namespace Options {
                interface RawApi extends ConnectionOption, HeadersOption {
                }
                interface HandledApi extends RawApi, ErrorStrategyOption {
                }
            }
        }
        namespace GetStatus {
            interface Options extends Options.Base, HeadersOption, AssistedErrorStrategyOption {
            }
            namespace Response {
                type OK = Status;
                type Error = undefined;
            }
            namespace Options {
                interface Base {
                    idOrName: string;
                }
                interface RawApi extends Base, ConnectionOption, HeadersOption {
                }
                interface HandledApi extends RawApi, ErrorStrategyOption {
                }
            }
        }
        namespace Category {
            namespace GetCategories {
                interface Options extends HeadersOption, AssistedErrorStrategyOption {
                }
                namespace Response {
                    type OK = StatusCategory[];
                    type Error = undefined;
                }
                namespace Options {
                    interface RawApi extends ConnectionOption, HeadersOption {
                    }
                    interface HandledApi extends RawApi, ErrorStrategyOption {
                    }
                }
            }
            namespace GetCategory {
                interface Options extends Options.Base, HeadersOption, AssistedErrorStrategyOption {
                }
                namespace Response {
                    type OK = StatusCategory;
                    type Error = undefined;
                }
                namespace Options {
                    interface Base {
                        idOrKey: string;
                    }
                    interface RawApi extends Base, ConnectionOption, HeadersOption {
                    }
                    interface HandledApi extends RawApi, ErrorStrategyOption {
                    }
                }
            }
        }
    }
}
//# sourceMappingURL=workflow.d.ts.map